;
;        ___ _____ ____  ____  _    ____   ___  ____
;       // /  //  //  / //  / /X _  //_ \ // (  //_ \
;       X__  //  //__/ /X__/ // \/ ///( //X_   ///( /
;         / //  // X  //  / //  / //   ///    //   /
;     .__/ /(  // // //  / //  / /(___/ X___ /(___/
;
;
;   ..the very first full-blown TI-83 adventure game.
;
;                   Linus Akesson 1999
;

ROOM_Bar	equ	0
ROOM_OSBar	equ	1
ROOM_OSGirl	equ	2
ROOM_OSCott	equ	3
ROOM_OSShop	equ	4
ROOM_Pond	equ	5
ROOM_Shop	equ	6
ROOM_Petrol	equ	7
ROOM_Yard	equ	8
ROOM_Girl	equ	9
ROOM_Cott	equ	10

HI_Quit		equ	1
HI_WalkTo	equ	2
HI_TalkTo	equ	3
HI_PickUp	equ	4
HI_Use		equ	5
HI_Inv		equ	6
;HI_GiveTo	equ	7
HI_UseWith	equ	8
;HI_Give	equ	9

VERB_Walkto	equ	0
VERB_Lookat	equ	1
VERB_Talkto	equ	2
VERB_Pickup	equ	3
VERB_Use	equ	4
;VERB_Give	equ	5

;VERB_GIVE	equ	6
;VERB_GiveFlower	equ	VERB_GIVE+0
;VERB_GiveRope	equ	VERB_GIVE+1
;VERB_GiveMug	equ	VERB_GIVE+2
;VERB_GiveCoins	equ	VERB_GIVE+3
;VERB_GiveCheese	equ	VERB_GIVE+4
;VERB_GiveMGlass	equ	VERB_GIVE+5
;VERB_GiveBranch	equ	VERB_GIVE+6
;VERB_GiveCage	equ	VERB_GIVE+7
;VERB_GiveFRod	equ	VERB_GIVE+8
;VERB_GiveMouse	equ	VERB_GIVE+9
;VERB_GiveNothng	equ	VERB_GIVE+10

VERB_USE	equ	5
VERB_UseCard	equ	VERB_USE+0
VERB_UseFlower	equ	VERB_USE+1
VERB_UseRope	equ	VERB_USE+2
VERB_UseMug	equ	VERB_USE+3
VERB_UseCoins	equ	VERB_USE+4
VERB_UseCheese	equ	VERB_USE+5
VERB_UseMGlass	equ	VERB_USE+6
VERB_UseBranch	equ	VERB_USE+7
VERB_UseCage	equ	VERB_USE+8
VERB_UseFRod	equ	VERB_USE+9
VERB_UseMouse	equ	VERB_USE+10
VERB_UseKey	equ	VERB_USE+11
;VERB_UseCard	equ	VERB_USE+11
VERB_UseNothng	equ	VERB_USE+12

INV_Flower	equ	1
INV_Rope	equ	2
INV_Mug		equ	3
INV_Coins	equ	4
INV_Cheese	equ	5
INV_MGlass	equ	6
INV_Branch	equ	7
INV_Cage	equ	8
INV_FishingRod	equ	9
INV_Mouse	equ	10
INV_Key		equ	11
INV_Card	equ	0	;12

PLOTSSCREEN	equ	8e29h
usermem_offset	equ	8565h
OP1		equ	8039h
PENCOL		equ	8252h
PENROW		equ	8253h
CURROW		equ	800ch

background	equ	8265h	;savesscreen
defobjlocation	equ	background+660

_ldHLind	equ	4000h
_CHKFINDSYM	equ	442ah
_ERRUNDEFINED	equ	467bh
_GRBUFCPY	equ	4b9ch
_ERRNOTENOUGHMEM equ	464eh
_INSERTMEM	equ	4432h
_clrScrn	equ	4761h
_vputs		equ	4781h
_homeUp		equ	4775h
_puts		equ	470dh
_cphlde		equ	4004h
_SFONT_LEN	equ	4a6ch
_runIndicOff	equ	4795h
_GRBUFCLR	equ	515bh
_POINTHLIND	equ	403ah
_A2POINTHLIND	equ	4036h
_vputmap	equ	477dh
_CLRLP		equ	429eh
_strCopy	equ	46adh
_newline	equ	473dh

statflags	equ	9
statsvalid	equ	6
onflags		equ	9
onInterrupt	equ	4
textflags	equ	5
textInverse	equ	3
textEraseBelow	equ	1
sgrflags	equ	20
textwrite	equ	7
grfSplit	equ	0
VertSplit	equ	1
asm_flag1	equ	33
asm_flag2	equ	34
asm_flag3	equ	35

flag1_KeyPressed		equ	0
flag1_Text0			equ	1
flag1_Text1			equ	2
flag1_osgirl_flowertaken	equ	3
flag1_dontdrawman		equ	4
flag1_forcemangfx		equ	5
flag1_allowviewinv		equ	6
flag1_alphapressed		equ	7

flag2_displayinv		equ	0
flag2_hasusedwell		equ	1
flag2_oscott_ropetaken		equ	2
flag2_laughingmanon		equ	3
flag2_dispitemlist		equ	4
flag2_shopkeeperstretch		equ	5
flag2_girlsdooropen		equ	6
flag2_displaygirl		equ	7

flag3_gotflower			equ	0
flag3_gotrope			equ	1
flag3_gotmug			equ	2
flag3_gotcoins			equ	3
flag3_gotcheese			equ	4
flag3_gotmglass			equ	5
flag3_gotbranch			equ	6
flag3_gotcage			equ	7

flag4_said_howsbusiness		equ	0
flag4_said_imighthavesomething	equ	1
flag4_cheesetaken		equ	2
;flag4_said_toupeestuff		equ	3
flag4_said_jokessuck		equ	4
flag4_triedtousepump		equ	5
;flag4_said_whycantusepump	equ	6
flag4_said_driverslicence	equ	7

flag5_bar_cheese		equ	0
flag5_manstaring		equ	1
flag5_seengirlonce		equ	2
flag5_cagetaken			equ	3
flag5_cageonrope		equ	4
flag5_cageonfloor		equ	5
flag5_branchlit			equ	6
flag5_dispdogeyes		equ	7

flag6_gotfishingrod		equ	0
flag6_isfishing			equ	1
flag6_gotmouse			equ	2
flag6_gotkey			equ	3
flag6_drawerunlocked		equ	4
flag6_gotcard			equ	5


VARS		equ	858fh		;STATVARS

currobj		equ	VARS+0
currobjs	equ	VARS+2
text0txt	equ	VARS+4
text1txt	equ	VARS+6
forcemangfx	equ	VARS+8
currentjokeptr	equ	VARS+10
bobsaddress	equ	VARS+12
textaddress	equ	VARS+14
roomsaddress	equ	VARS+16

BYTEVARS	equ	VARS+18

curronum		equ	BYTEVARS+0
currroom		equ	BYTEVARS+1
currverb		equ	BYTEVARS+2
manxpos			equ	BYTEVARS+3
manypos			equ	BYTEVARS+4
mandir			equ	BYTEVARS+5
manwalkgfx		equ	BYTEVARS+6
text0xpos		equ	BYTEVARS+7
text0ypos		equ	BYTEVARS+8
mantalkflag		equ	BYTEVARS+9
osbar_manlaughflag	equ	BYTEVARS+10
osbar_manlaughcount	equ	BYTEVARS+11
osbar_manhahoflag	equ	BYTEVARS+12
osbar_manhahocount	equ	BYTEVARS+13
nopbyte			equ	BYTEVARS+14
text1xpos		equ	BYTEVARS+15
text1ypos		equ	BYTEVARS+16
;otherobject		equ	BYTEVARS+17	;obsolete
bartendertalkflag	equ	BYTEVARS+18
laughingmantalkflag	equ	BYTEVARS+19
shopkeepertalkflag	equ	BYTEVARS+20
campfirestate		equ	BYTEVARS+21	;0=new, 1=with fluid, 2=lit
flags4			equ	BYTEVARS+22
ilistnumitems		equ	BYTEVARS+23
ilistcurr		equ	BYTEVARS+24
currentjoke		equ	BYTEVARS+25
currtextbank		equ	BYTEVARS+26
petrolmantalkflag	equ	BYTEVARS+27
fireflipflop		equ	BYTEVARS+28
flags5			equ	BYTEVARS+29
ropestate		equ	BYTEVARS+30	;0=no, 1=painting, 2=hook, 3=both
girlxpos		equ	BYTEVARS+31
girlypos		equ	BYTEVARS+32
;girldir		equ	BYTEVARS+33	;obsolete
girltalkflag		equ	BYTEVARS+34
branchfirecount		equ	BYTEVARS+35
dogeyesx		equ	BYTEVARS+36
flags6			equ	BYTEVARS+37
scrollpos		equ	BYTEVARS+38
sinusbgoffset		equ	BYTEVARS+39
introscrolltxtlen	equ	BYTEVARS+40
ilistdata		equ	BYTEVARS+41	;UPDATE!

gfx_pointer		equ	0
gfx_manleft		equ	1
gfx_manback		equ	2
gfx_manright		equ	3
gfx_manfront		equ	4
gfx_manleft1		equ	5
gfx_manback1		equ	6
gfx_manright1		equ	7
gfx_manfront1		equ	8
gfx_manleft2		equ	9
gfx_manback2		equ	10
gfx_manright2		equ	11
gfx_manfront2		equ	12
gfx_manlefttalk		equ	13
gfx_manrighttalk	equ	14
gfx_manfronttalk	equ	15
gfx_osbar_manleft	equ	16
gfx_osbar_manright	equ	17
gfx_osgirl_flower	equ	18
gfx_manrightstretch	equ	19
gfx_inv_flower		equ	20
gfx_inv_rope		equ	21
gfx_oscott_norope	equ	22
gfx_inv_mug		equ	23
gfx_bar_nomug		equ	24
gfx_manrightstretchup	equ	25
gfx_bartender_talk	equ	26
gfx_laughingman_talk	equ	27
gfx_shopkeeper_talk	equ	28
gfx_inv_coins		equ	29
gfx_inv_cheese		equ	30
gfx_inv_mglass		equ	31
gfx_shopkeeper_stretch	equ	32
gfx_shop_nomglass	equ	33
gfx_petrolman_talk	equ	34
gfx_inv_branch		equ	35
gfx_fire1		equ	36
gfx_fire2		equ	37
gfx_bar_cheese		equ	38
gfx_bar_rope1		equ	39
gfx_bar_rope2		equ	40
gfx_bar_rope3		equ	41
gfx_bar_rope4		equ	42
gfx_osgirl_door		equ	43
gfx_girlleft		equ	44
gfx_girltalk		equ	45
gfx_manstaring		equ	46
gfx_yard_nobranch	equ	47
gfx_inv_cage		equ	48
gfx_cage		equ	49
gfx_inv_branchfire1	equ	50
gfx_inv_branchfire2	equ	51
gfx_maneyes		equ	52
gfx_dogeyes		equ	53
gfx_inv_fishingrod	equ	54
gfx_inv_mouse		equ	55
gfx_inv_key		equ	56
gfx_inv_card		equ	57

		include	textref.i

		org	9327h

		;ld	hl,390		;biggest txt#?.asm.bin
		;push	hl
		;call	_ERRNOTENOUGHMEM
		;pop	hl
		;push	hl
		;ld	de,textunpackbuffer
		;call	_INSERTMEM
		;pop	de
		;ld	hl,(usermem_offset)
		;add	hl,de
		;ld	(usermem_offset),hl

		jp	startofprogram

; ===================================================
; === unpack - Unpack data.                       ===
; === INPUTS: hl is packed data (with packedsize) ===
; ===         de is allocated memory              ===
; ===================================================

Unpack:		ld	(up_destptr),de
		ld	c,(hl)
		inc	hl
		ld	b,(hl)		;bc is packedsize
		inc	hl
		inc	hl		;get past 'P'
		ld	e,(hl)
		inc	hl
		ld	d,(hl)		;de is originalsize
		inc	hl
		ld	(up_srcptr),hl
		dec	hl
		dec	hl
		dec	hl
		add	hl,bc		;hl is past end of command table
		push	hl
		ld	hl,(up_destptr)
		add	hl,de
		ld	(up_endptr),hl
		pop	hl

		ld	a,1

up_parseloop:	push	hl
		ld	hl,(up_endptr)
		ld	de,(up_destptr)
		scf
		sbc	hl,de
		pop	hl
		ret	c		;done

		cp	1
		rra
		call	z,up_newbyte

		jr	c,up_cmdcopy

		ld	b,3		;BITS_READ
		call	up_read
		push	hl
		ld	hl,(up_srcptr)
		ld	de,(up_destptr)
		;inc	c
		ldir
		ld	(up_srcptr),hl
		ld	(up_destptr),de
		pop	hl
		jr	up_parseloop

up_cmdcopy:	ld	b,6		;BITS_COPYPOS
		call	up_read
		push	hl
		ld	hl,(up_destptr)
		ld	e,l
		ld	d,h
		;inc	c
		scf
		sbc	hl,bc
		ex	(sp),hl
		ld	b,3		;BITS_COPYLEN
		call	up_read
		ex	(sp),hl
		;inc	c
		ldir
		ld	(up_destptr),de
		pop	hl
		jr	up_parseloop

up_newbyte:	dec	hl
		ld	a,(hl)
		scf
		rra
		ret

up_read:	ld	c,0
up_r_1:		cp	1
		rra
		call	z,up_newbyte
		rl	c
		djnz	up_r_1
		inc	c
		ret

up_endptr	equ	8039h
up_srcptr	equ	803bh
up_destptr	equ	803dh


;-------------------------------------------------------------------------------


startofprogram:	ld	hl,BYTEVARS
		ld	b,ilistdata-BYTEVARS
		call	_CLRLP			;clear all vars
		xor	a
		ld	(iy+asm_flag1),a
		ld	(iy+asm_flag2),a
		ld	(iy+asm_flag3),a
		set	flag1_allowviewinv,(iy+asm_flag1)
		set	flag2_laughingmanon,(iy+asm_flag2)
		set	textwrite,(iy+sgrflags)
		res	grfSplit,(iy+sgrflags)
		res	VertSplit,(iy+sgrflags)
		ld	hl,jokearray
		ld	(currentjokeptr),hl
		dec	a	;ld a,ffh
		ld	(currtextbank),a

		;ld	hl,flags5				;REMOVE THIS
		;set	flag5_branchlit,(hl)			;REMOVE THIS
		;set	flag2_girlsdooropen,(iy+asm_flag2)	;REMOVE THIS
		;ld	hl,flags6				;REMOVE THIS
		;set	flag6_gotcard,(hl)			;REMOVE THIS

		ld	hl,filenamez
		rst	32	;_MOV9TOOP1
		call	_CHKFINDSYM
		jp	c,_ERRUNDEFINED
		;inc	de
		;inc	de
		ex	de,hl
		push	hl
		ld	a,1
		call	pointhlind_add
		ld	(roomsaddress),hl
		pop	hl
		push	hl
		ld	a,2
		call	pointhlind_add
		ld	(bobsaddress),hl
		pop	hl
		ld	a,3
		call	pointhlind_add
		ld	(textaddress),hl

		call	_runIndicOff

		ld	a,108+24
		ld	(introscrolltxtlen),a
		ld	l,txt_introscrolltext

		call	Intro


		ld	a,ffh
		ld	(currroom),a

		call	Petrol_Enter		;run the game

Quit:		res	statsvalid,(iy+statflags)
		res	onInterrupt,(iy+onflags)
		res	textInverse,(iy+textflags)
		res	textwrite,(iy+sgrflags)
		call	_clrScrn
		ld	hl,0103h
		ld	(CURROW),hl
		ld	hl,050ch
		ld	(PENCOL),hl
		ld	l,txt_endtxt1
		call	unpacktext
		call	_vputs
		ld	hl,0c05h
		ld	(PENCOL),hl
		ld	l,txt_endtxt2
		call	unpacktext
		call	_vputs
		ld	hl,txt_space		;workaround so that the os won't
		call	_puts			;switch to the graph-screen
		ret

QuitPop:	pop	hl
		jr	Quit

UpdateDisplay:	bit	flag2_displayinv,(iy+asm_flag2)
		jp	z,ud_noinvdisplay

		call	_GRBUFCLR
		ld	hl,PLOTSSCREEN+12*55
		push	hl

		ld	hl,0101h
		ld	(PENCOL),hl
		res	textInverse,(iy+textflags)
		ld	a,txt_youarecarrying
		call	vputsobjectname

		ld	hl,01h*256+gfx_inv_flower	;3 bit 0
		call	drawinventory3
		ld	hl,08h*256+gfx_inv_coins	;3 bit 3
		call	drawinventory3
		ld	hl,20h*256+gfx_inv_mglass	;3 bit 5
		call	drawinventory3
		ld	hl,02h*256+gfx_inv_rope		;3 bit 1
		call	drawinventory3
		ld	hl,04h*256+gfx_inv_mug		;3 bit 2
		call	drawinventory3
		ld	hl,10h*256+gfx_inv_cheese	;3 bit 4
		call	drawinventory3
		ld	hl,04h*256+gfx_inv_mouse	;6 bit 2
		call	drawinventory6

		bit	flag3_gotbranch,(iy+asm_flag3)
		jr	z,ud_inv_nobranch
		ld	l,gfx_inv_branch
		call	drawcornersol
		ld	a,(flags5)
		bit	flag5_branchlit,a
		jr	z,ud_inv_nobranch
		ld	hl,branchfirecount
		inc	(hl)
		ld	a,(hl)
		ld	l,gfx_inv_branchfire1
		bit	3,a	;speed of branchfire
		jr	z,ud_inv_branch1
		inc	l
ud_inv_branch1:	call	drawcornersol

ud_inv_nobranch:
		ld	hl,80h*256+gfx_inv_cage		;3 bit 7
		call	drawinventory3
		ld	hl,20h*256+gfx_inv_card		;6 bit 5
		call	drawinventory6
		ld	hl,08h*256+gfx_inv_key		;6 bit 3
		call	drawinventory6
		ld	hl,01h*256+gfx_inv_fishingrod	;6 bit 0
		call	drawinventory6

		jp	ud_invskiphere

ud_noinvdisplay:
		ld	hl,background
		ld	de,PLOTSSCREEN
		ld	bc,12*55
		ldir
		push	de

		ld	a,(currroom)
		cp	ROOM_OSBar
		jr	nz,ud_2

		call	ud_MightDrawGirl

		bit	flag2_laughingmanon,(iy+asm_flag2)
		jr	z,ud_OSBar_2
		ld	a,(osbar_manlaughcount)
		dec	a
		jr	nz,ud_OSBar_L_1
		ld	a,(osbar_manlaughflag)
		xor	1
		ld	(osbar_manlaughflag),a
		ld	a,10
ud_OSBar_L_1:	ld	(osbar_manlaughcount),a

		ld	a,(osbar_manlaughflag)
		or	a
		jp	z,ud_endroomcode
		ld	l,gfx_osbar_manleft
		;ld	de,1125h
		;push	de
		call	drawcornersol
		;pop	de
		ld	l,gfx_osbar_manright
		call	drawcornersol
		jp	ud_endroomcode

ud_OSBar_2:	ld	a,(laughingmantalkflag)
		bit	0,a
		jp	z,ud_endroomcode
		ld	l,gfx_laughingman_talk
		;ld	de,1a1fh
		call	drawcornersol
		jp	ud_endroomcode

ud_2:		cp	ROOM_OSGirl
		jr	nz,ud_3

		bit	flag2_girlsdooropen,(iy+asm_flag2)
		jr	z,ud_OSGirl_nodoor

		ld	l,gfx_osgirl_door
		call	drawcornersol
ud_OSGirl_nodoor:
		call	ud_MightDrawGirl

		bit	flag1_osgirl_flowertaken,(iy+asm_flag1)
		jp	nz,ud_endroomcode

		ld	l,gfx_osgirl_flower
		;ld	de,36*256+79
		call	drawcorner
		jp	ud_endroomcode

ud_3:		cp	ROOM_OSCott
		jr	nz,ud_4

		bit	flag2_oscott_ropetaken,(iy+asm_flag2)
		jp	z,ud_endroomcode

		ld	l,gfx_oscott_norope
		;ld	de,1530h
		call	drawcornersol
		jp	ud_endroomcode

ud_4:		cp	ROOM_Bar
		jr	nz,ud_5

		ld	a,(bartendertalkflag)
		bit	0,a
		jr	z,ud_Bar_1
		ld	l,gfx_bartender_talk
		;ld	de,1048h
		call	drawcornersol

ud_Bar_1:	ld	a,(flags5)
		bit	flag5_bar_cheese,a
		jr	z,ud_Bar_2
		ld	l,gfx_bar_cheese
		;ld	de,2827h
		call	drawcornersol

ud_Bar_2:	ld	a,(ropestate)
		or	a
		jr	z,ud_Bar_3
		dec	a	;cp 1, painting
		jr	nz,ud_Bar_2a
		ld	hl,PLOTSSCREEN+12*1+2
		ld	c,00000001b
		ld	b,27
		jr	ud_Bar_2a_1

ud_Bar_2a:	dec	a	;cp 2, rope
		jr	nz,ud_Bar_2b
		ld	hl,PLOTSSCREEN+12*38+10
		ld	c,00001000b
		ld	b,17

ud_Bar_2a_1:	call	drawvertline
		jr	ud_Bar_3

ud_Bar_2b:	ld	c,gfx_bar_rope1
		ld	b,4
ud_Bar_2b_lp:	push	bc
		ld	l,c
		call	drawcornersol
		pop	bc
		inc	c
		djnz	ud_Bar_2b_lp

ud_Bar_3:	bit	flag3_gotmug,(iy+asm_flag3)
		jp	z,ud_Bar_cage

		ld	l,gfx_bar_nomug
		ld	de,0f40h
		call	drawgfx

ud_Bar_cage:	ld	a,(flags5)
		bit	flag5_cageonrope,a
		jr	z,ud_Bar_cage1
		ld	l,gfx_cage
		ld	de,1429h
		call	drawgfx
		jp	ud_endroomcode

ud_Bar_cage1:	bit	flag5_cageonfloor,a
		jp	z,ud_endroomcode
		ld	l,gfx_cage
		ld	de,2127h
		call	drawgfx
		jp	ud_endroomcode


ud_5:		cp	ROOM_Shop
		jr	nz,ud_6

		bit	flag2_shopkeeperstretch,(iy+asm_flag2)
		jr	z,ud_Shop_nostretch
		ld	l,gfx_shopkeeper_stretch
		;ld	de,0621h
		call	drawcornersol
ud_Shop_nostretch:
		bit	flag3_gotmglass,(iy+asm_flag3)
		jr	z,ud_Shop_notgot
		ld	l,gfx_shop_nomglass
		ld	de,091eh
		call	drawgfx
ud_Shop_notgot:
		ld	a,(shopkeepertalkflag)
		bit	0,a
		jr	z,ud_endroomcode
		ld	l,gfx_shopkeeper_talk
		;ld	de,0c26h
		call	drawcornersol
		jr	ud_endroomcode

ud_6:		cp	ROOM_Petrol
		jr	nz,ud_7

		ld	a,(petrolmantalkflag)
		bit	0,a
		jr	z,ud_endroomcode
		ld	l,gfx_petrolman_talk
		;ld	de,1045h
		call	drawcornersol
		jr	ud_endroomcode

ud_7:		cp	ROOM_Pond
		jr	nz,ud_8

		ld	a,(flags6)
		bit	flag6_isfishing,a
		jr	z,ud_Pond_notf

		ld	hl,PLOTSSCREEN+12*26+1
		ld	c,00010000b
		ld	b,16
		call	drawvertline

ud_Pond_notf:	ld	a,(campfirestate)
		cp	2
		jr	nz,ud_endroomcode
		ld	hl,fireflipflop
		ld	a,(hl)
		inc	a
		ld	(hl),a
		ld	l,gfx_fire1
		bit	4,a		;speed of fire
		jr	z,ud_Pond_f1
		ld	l,gfx_fire2
ud_Pond_f1:	;ld	de,1346h
		call	drawcornersol
		jr	ud_endroomcode

ud_8:		cp	ROOM_Yard
		jr	nz,ud_9

		bit	flag3_gotbranch,(iy+asm_flag3)
		jr	z,ud_Yard_1
		ld	l,gfx_yard_nobranch
		call	drawcornersol

ud_Yard_1:	ld	a,(flags5)
		bit	flag5_cagetaken,a
		jr	nz,ud_endroomcode
		ld	l,gfx_cage
		ld	de,1d05h
		call	drawgfx
		jr	ud_endroomcode

ud_9:		cp	ROOM_Cott
		jr	nz,ud_10

		ld	a,(flags5)
		bit	flag5_dispdogeyes,a
		jr	z,ud_endroomcode
		ld	de,(dogeyesx)
		ld	d,40
		ld	l,gfx_dogeyes
		call	drawsolid
		;jr	ud_endroomcode

ud_10:
ud_endroomcode:	bit	flag1_dontdrawman,(iy+asm_flag1)
		jr	nz,ud_noman
		
		ld	de,(manxpos)
		bit	flag1_forcemangfx,(iy+asm_flag1)
		jr	z,ud_stdman

		ld	hl,(forcemangfx)
		call	drawgfx
		jr	ud_noman

ud_stdman:	ld	a,(mandir)
		ld	hl,manwalkgfx
		bit	1,(hl)
		jr	z,ud_stdman_1
		add	a,4
ud_stdman_1:	ld	l,a
		inc	l
		call	drawgfx

		ld	a,(mantalkflag)
		bit	0,a
		jr	z,ud_noman

ud_mantalking:	ld	hl,mantalkgfxarray
		ld	b,0
		ld	a,(mandir)
		ld	c,a
		;sla	c
		add	hl,bc
		ld	l,(hl)
		ld	de,(manxpos)
		call	drawgfx

ud_noman:	ld	a,(flags5)
		bit	flag5_manstaring,a
		jr	z,ud_dontstare
		ld	l,gfx_manstaring
		call	drawcornersol
ud_dontstare:

ud_invskiphere:
		pop	hl
		ld	b,12
		call	_CLRLP
		ld	(hl),ffh
		ld	de,PLOTSSCREEN+12*56+1
		ld	bc,12*7+11
		ldir

		ld	ix,(currobj)
		ld	d,(ix+objY)
		ld	e,(ix+objX)
		ld	l,gfx_pointer
		call	drawgfx

		bit	flag2_displayinv,(iy+asm_flag2)
		jr	nz,ud_notxt1
		bit	flag1_Text1,(iy+asm_flag1)
		jr	z,ud_notxt1
		ld	hl,(text1xpos)
		ld	(PENCOL),hl
		res	textInverse,(iy+textflags)
		set	textEraseBelow,(iy+textflags)
		call	vputspace
		ld	hl,(text1txt)
		call	_vputs
		call	vputspace
ud_notxt1:
		bit	flag1_Text0,(iy+asm_flag1)
		jr	z,ud_notxt0
		ld	hl,(text0xpos)
		ld	(PENCOL),hl
		res	textInverse,(iy+textflags)
		set	textEraseBelow,(iy+textflags)
		call	vputspace
		ld	hl,(text0txt)
		call	_vputs
		call	vputspace
ud_notxt0:
		set	textInverse,(iy+textflags)
		set	textEraseBelow,(iy+textflags)
		ld	hl,3901h
		ld	(PENCOL),hl
		ld	a,(currverb)
		;cp	3		;give/take
		;jr	nz,ud_notgivetake
		;bit	flag2_displayinv,(iy+asm_flag2)
		;jr	z,ud_notgivetake
		;ld	a,5
ud_notgivetake:	;cp	VERB_GIVE
		cp	VERB_USE
		jr	nc,ud_verbcomp

		add	a,txt_walkto
		call	vputsobjectname
		jr	ud_verbdone

ud_verbcomp:	sub	VERB_USE
		push	af
		ld	a,txt_use
		call	vputsobjectname
		call	vputspace
		pop	af

		ld	hl,inventorynames
		ld	e,a
		ld	d,0
		add	hl,de
		ld	a,(hl)
		call	vputsobjectname

		call	vputspace
		ld	a,txt_with
		call	vputsobjectname

ud_verbdone:	call	vputspace

		ld	hl,(currobj)
		ld	de,objText
		add	hl,de
		ld	a,(hl)
		call	vputsobjectname

		bit	flag2_dispitemlist,(iy+asm_flag2)
		jr	z,ud_noitemlist

		ld	a,(ilistnumitems)
		ld	b,a
		ld	c,0
		ld	hl,0201h
		ld	(PENCOL),hl
		ld	hl,ilistdata
ud_ilist_lp:	res	textInverse,(iy+textflags)
		ld	a,(ilistcurr)
		cp	c	;current item?
		jr	nz,ud_ilist_ncurr
		set	textInverse,(iy+textflags)
ud_ilist_ncurr:	push	bc
		push	hl
		call	_ldHLind
		call	unpacktext
ud_ilist_lp2:	push	hl
		call	vputspace
		pop	hl
		push	hl
		call	_vputs
		call	vputspace
		ld	a,1
		ld	(PENCOL),a
		ld	a,(PENROW)
		add	a,7
		ld	(PENROW),a
		pop	hl
		ld	bc,256
		xor	a
		cpir
		ld	a,(hl)
		or	a
		jr	nz,ud_ilist_lp2
		ld	hl,PENROW
		inc	(hl)
		pop	hl
		inc	hl
		inc	hl
		inc	hl
		pop	bc
		inc	c
		djnz	ud_ilist_lp

ud_noitemlist:	jp	_GRBUFCPY

ud_MightDrawGirl:
		bit	flag2_displaygirl,(iy+asm_flag2)
		ret	z

		ld	l,gfx_girlleft
		ld	de,(girlxpos)
		call	drawgfx

		ld	a,(girltalkflag)
		bit	0,a
		ret	z

		ld	l,gfx_girltalk
		ld	de,(girlxpos)
		jp	drawgfx

vputsobjectname:
		call	locateobjectname
		jp	_vputs

locateobjectname:
		ld	hl,(textaddress)
		push	hl
		push	af
		xor	a
		call	pointhlind_add
		pop	af
		call	_A2POINTHLIND
		pop	de
		add	hl,de
		ret

drawvertline:	ld	de,12
		ld	a,c
		or	(hl)
		ld	(hl),a
		add	hl,de
		djnz	drawvertline
		ret

LoadRoomDef:	ld	hl,defobjlocation

LoadRoom:	ld	(currobjs),hl
		ld	(currobj),hl
		ld	(currroom),a
		push	af
		xor	a
		ld	(curronum),a

lr_objofflp:	ld	a,(hl)		;flag
		or	a
		jr	nz,lr_objon
		ld	a,(curronum)
		inc	a
		ld	(curronum),a
		ld	de,objSIZE
		add	hl,de
		jr	lr_objofflp

lr_objon:	;ld	hl,gfxfilename
		;ld	a,'A'
		;call	FindProgram
		pop	af
		cp	ROOM_Cott
		jr	nz,lr_notcott

		ld	hl,background
		ld	a,ffh
		ld	(hl),a
		ld	de,background+1
		ld	bc,12*55-1
		ldir			;darknesSsss!
		ret

lr_notcott:	ld	hl,(roomsaddress)	;programstart in hl
		call	pointhlind_add
		ld	de,background
		jp	Unpack

UDHandleInput:	call	UpdateDisplay
		;jr	HandleInput

HandleInput:	in	a,(3)
		bit	3,a
		jr	z,hi_kon
		bit	flag1_KeyPressed,(iy+asm_flag1)
		jr	nz,hi_release
		set	flag1_KeyPressed,(iy+asm_flag1)
		ld	a,bfh
		out	(1),a
		ld	hl,currverb
		ld	b,4
		in	a,(1)
		rra
		jr	nc,hi_kgraph
		rra
		jr	nc,hi_ktrace
		rra
		jr	nc,hi_kzoom
		rra
		jr	nc,hi_kwindow
		rra
		jr	nc,hi_kyequ
		rra
		jr	nc,hi_k2nd
		ld	a,feh
		out	(1),a
		ld	ix,(currobj)
		in	a,(1)
		cp	f7h
		jr	z,hi_kup
		cp	fbh
		jp	z,hi_kright
		cp	feh
		jr	z,hi_kdown
		cp	fdh
		jp	z,hi_kleft
		ld	a,dfh
		out	(1),a
		in	a,(1)
		cp	7fh
		jp	z,hi_kalpha
		res	flag1_KeyPressed,(iy+asm_flag1)
hi_retnc:	xor	a
		ret

hi_release:	ld	bc,ff01h
		xor	a
		out	(1),a
		in	a,(1)
		out	(c),b
		inc	a	;cp ffh
		jr	nz,hi_retnc
		res	flag1_KeyPressed,(iy+asm_flag1)
		xor	a
		ret

hi_kon:		ld	a,HI_Quit
		or	a
		ret

hi_kyequ:	dec	b

hi_kwindow:	dec	b

hi_kzoom:	dec	b

hi_ktrace:	dec	b

hi_kgraph:	ld	(hl),b
		xor	a
		ret

hi_k2nd:	;ld	hl,(curronum)
		ld	a,(currverb)
		or	a
		jr	z,hi_vwalkto
		dec	a	;cp VERB_Lookat
		jp	z,hi_vlookat
		dec	a	;cp VERB_Talkto
		jp	z,hi_vtalkto
		dec	a	;cp VERB_Pickup
		jp	z,hi_vpickup
		dec	a	;cp VERB_Use
		jp	z,hi_vuse
		;ld	a,(currverb)
		;cp	VERB_USE
		;jp	c,hi_vgiveto
		jp	hi_vusewith

hi_kup:		ld	a,(ix+objUp)
		cp	ffh
		jr	z,hi_retnc
		call	addressobject
		jr	nc,hi_arrowok
		push	hl
		pop	ix
		jr	hi_kup

hi_kdown:	ld	a,(ix+objDown)
		cp	ffh
		jr	z,hi_retnc
		call	addressobject
		jr	nc,hi_arrowok
		push	hl
		pop	ix
		jr	hi_kdown

hi_kleft:	ld	a,(ix+objLeft)
		cp	ffh
		jp	z,hi_retnc
		call	addressobject
		jr	nc,hi_arrowok
		push	hl
		pop	ix
		jr	hi_kleft

hi_kright:	ld	a,(ix+objRight)
		cp	ffh
		jp	z,hi_retnc
		call	addressobject
		jr	nc,hi_arrowok
		push	hl
		pop	ix
		jr	hi_kright

hi_arrowok:	ld	(curronum),a
		ld	(currobj),hl
		xor	a
		ret

hi_vwalkto:	bit	flag2_displayinv,(iy+asm_flag2)
		ret	nz
		call	walktocurrobj
		ld	hl,normalwalktos
		ld	b,normalwalktos_l
hi_vwt_1:	ld	e,(hl)
		inc	hl
		ld	d,(hl)
		inc	hl
		push	hl
		ld	hl,(curronum)	;and currroom
		call	_cphlde
		pop	hl
		jr	z,hi_vwt_found
		inc	hl
		inc	hl
		djnz	hi_vwt_1
		ld	a,HI_WalkTo
		or	a
		ret

hi_vwt_found:	call	_ldHLind	;get entry point
		ex	(sp),hl		;set it as return address
		ret			;and wheeee!

hi_vlookat:	ld	a,(currroom)
		cp	ROOM_Shop
		jr	nz,hi_vlookat_def
		bit	flag2_displayinv,(iy+asm_flag2)
		jr	nz,hi_vlookat_def
		ld	a,(curronum)
		cp	03	;first sellable item
		jr	c,hi_vlookat_def
		ld	hl,(currobj)
		ld	de,objLookAt
		add	hl,de
		ld	l,(hl)
		call	sayshopkeeper
		xor	a
		ld	(currverb),a
		ret

hi_vlookat_def:	call	walktocurrobj
		ld	hl,(currobj)
		ld	de,objLookAt
		add	hl,de
		ld	a,(hl)
		ld	l,a
		or	a
		call	nz,sayman
		xor	a
		ld	(currverb),a
		ret

hi_vtalkto:	ld	a,HI_TalkTo
		or	a
		ret

hi_vpickup:	call	walktocurrobj
		ld	hl,pickuptable
		ld	bc,pickuptable_l
		ld	a,(currroom)
		cpir
		call	nz,cantpickup
		ld	a,HI_PickUp
		or	a
		ret

hi_vuse:	bit	flag2_displayinv,(iy+asm_flag2)
		jr	nz,hi_vu_1
		call	walktocurrobj
		ld	hl,usetable
		ld	bc,usetable_l
		ld	a,(currroom)
		cpir
		call	nz,cantdothat
hi_vu_1:	ld	a,HI_Use
		or	a
		ret

hi_vgiveto:	;ld	ix,(currobj)
		;call	walktoobject
		;ld	a,HI_GiveTo
		;or	a
		;ret

hi_vusewith:	bit	flag2_displayinv,(iy+asm_flag2)
		jr	nz,hi_vuw_1
		ld	hl,usewithtable
		ld	bc,usewithtable_l
		ld	a,(currroom)
		cpir
hi_vuw_1:	call	nz,cantdothat
		ld	a,HI_UseWith
		or	a
		ret

usetable:	defm	ROOM_Petrol,ROOM_OSCott,ROOM_OSGirl,ROOM_Bar,ROOM_Girl
usetable_l	equ	$-usetable

usewithtable:	defm	ROOM_Pond,ROOM_Bar,ROOM_OSGirl,ROOM_Shop,ROOM_Girl
usewithtable_l	equ	$-usewithtable

pickuptable:	defm	ROOM_Bar,ROOM_OSGirl,ROOM_OSCott,ROOM_Shop,ROOM_Yard,ROOM_Cott
pickuptable_l	equ	$-pickuptable

hi_kalpha:	set	flag1_alphapressed,(iy+asm_flag1)
		xor	a	;set z
		bit	flag1_allowviewinv,(iy+asm_flag1)
		ret	z
		res	flag1_alphapressed,(iy+asm_flag1)

		res	flag1_allowviewinv,(iy+asm_flag1)
		set	flag2_displayinv,(iy+asm_flag2)

		ld	hl,(manxpos)
		push	hl
		ld	hl,40+52*256
		ld	(manxpos),hl
		ld	a,(curronum)
		push	af
		ld	hl,(currobj)
		push	hl
		ld	hl,(currobjs)
		push	hl
		ld	hl,objsInventory
		ld	(currobjs),hl
		xor	a
		ld	(curronum),a
hi_ka_objofflp:	ld	a,(hl)		;flag
		or	a
		jr	nz,hi_ka_objon
		ld	a,(curronum)
		inc	a
		ld	(curronum),a
		ld	de,objSIZE
		add	hl,de
		jr	hi_ka_objofflp
hi_ka_objon:	ld	(currobj),hl
		
hi_ka_loop:	call	UDHandleInput
		jr	z,hi_ka_nc
		cp	HI_Quit
		jr	z,hi_ka_exit
		cp	HI_Use
		jr	z,hi_ka_use
hi_ka_retnoverb:
		xor	a
		ld	(currverb),a
		jr	hi_ka_exit	;(loop)

hi_ka_nc:	bit	flag1_alphapressed,(iy+asm_flag1)
		jr	nz,hi_ka_exit
		jr	hi_ka_loop

hi_ka_exit:	pop	hl
		ld	(currobjs),hl
		pop	hl
		ld	(currobj),hl
		pop	af
		ld	(curronum),a
		pop	hl
		ld	(manxpos),hl

		res	flag2_displayinv,(iy+asm_flag2)
		set	flag1_allowviewinv,(iy+asm_flag1)

		xor	a
		ret

hi_ka_use:	ld	a,(curronum)
		;or	a
		;jr	z,hi_ka_loop
		;ld	(otherobject),a
		add	a,VERB_USE	;-1
		ld	(currverb),a
		jr	hi_ka_exit	;(loop)

walktocurrobj:	ld	ix,(currobj)

walktoobject:	bit	flag2_displayinv,(iy+asm_flag2)
		ret	nz
		ld	h,(ix+objManY)
		ld	l,(ix+objManX)
		push	ix
		call	walktopoint
		pop	ix
		ld	a,(ix+objManDir)
		ld	(mandir),a
		xor	a
		ld	(manwalkgfx),a
		ret

addressobject:	ld	c,a
		ld	hl,(currobjs)
		or	a
		jr	z,aobj_sk
		ld	b,a
		ld	de,objSIZE
aobj_lp:	add	hl,de
		djnz	aobj_lp
aobj_sk:	ld	a,(hl)
		sub	1	;set carry if flag was off
		ld	a,c
		ret

activateobject:	ld	(curronum),a
		call	addressobject
		ld	(currobj),hl
		ret

sayman:		call	unpacktext
		ld	de,(manxpos)
		ld	a,d
		sub	36
		ret	c
		ld	d,a
		ld	ix,mantalkflag
		jr	say0

saygirl:	call	unpacktext
		ld	de,(girlxpos)
		ld	a,d
		sub	39
		ld	d,a
		ld	ix,girltalkflag
		jp	say1

saybartender:	call	unpacktext
		ld	de,024ah
		ld	ix,bartendertalkflag
		jr	say1

saylaughingmanhuh:
		push	hl
		ld	l,txt_huh
		call	saylaughingman
		pop	hl

saylaughingman:	call	unpacktext
		ld	de,0a24h
		ld	ix,laughingmantalkflag
		bit	flag2_laughingmanon,(iy+asm_flag2)
		push	af
		res	flag2_laughingmanon,(iy+asm_flag2)
		call	say1
		pop	af
		ret	z
		set	flag2_laughingmanon,(iy+asm_flag2)
		ret

sayshopkeeper:	call	unpacktext
		ld	de,022ah
		ld	ix,shopkeepertalkflag
		jr	say1

petrolmantwyt:	ld	l,txt_thatswhatyouthink
		;jp	saypetrolman

saypetrolman:	call	unpacktext
		ld	de,0339h
		ld	ix,petrolmantalkflag
		jr	say1

say0:		ld	a,(hl)
		or	a
		ret	z
		push	de
		call	calctextwidth
		srl	a
		neg
		add	a,e
		ld	e,a
		ld	(text0xpos),de
		ld	(text0txt),hl
		set	flag1_Text0,(iy+asm_flag1)
s0_lp:		push	hl
		push	ix
		;ld	b,2
s0_w8:		;push	bc
		call	UpdateDisplay
		call	UpdateDisplay
		;pop	bc
		;djnz	s0_w8
		pop	ix
		pop	hl
		inc	hl
		ld	a,(hl)
		ld	(ix+0),a
		or	a
		jr	nz,s0_lp
		inc	hl
		res	flag1_Text0,(iy+asm_flag1)
		pop	de
		jr	say0

say1:		ld	a,(hl)
		or	a
		ret	z
		push	de
		call	calctextwidth
		srl	a
		neg
		add	a,e
		ld	e,a
		ld	(text1xpos),de
		ld	(text1txt),hl
		set	flag1_Text1,(iy+asm_flag1)
s1_lp:		push	hl
		push	ix
		;ld	b,2
s1_w8:		;push	bc
		call	UpdateDisplay
		call	UpdateDisplay
		;pop	bc
		;djnz	s1_w8
		pop	ix
		pop	hl
		inc	hl
		ld	a,(hl)
		ld	(ix+0),a
		or	a
		jr	nz,s1_lp
		inc	hl
		res	flag1_Text1,(iy+asm_flag1)
		pop	de
		jr	say1

calctextwidth:	push	hl
		push	de
		xor	a
ctw_lp:		push	af
		ld	a,(hl)
		or	a
		jr	z,ctw_done
		push	hl
		ld	h,0
		ld	l,a
		add	hl,hl
		add	hl,hl
		add	hl,hl
		call	_SFONT_LEN
		pop	hl
		pop	af
		add	a,b
		inc	hl
		jr	ctw_lp
ctw_done:	pop	af
		pop	de
		pop	hl
		ret

drawcorner:	ld	de,365fh	;lower right corner
		;jr	drawgfx

drawgfx:	call	locatebobchangepos
					;hl is src, de is dest, c is x offset
		ld	b,(hl)
		inc	hl
		push	hl
		push	de
		ld	e,b
		ld	d,0
		sla	e
		add	hl,de
		pop	ix		;ix is dest

		push	bc
		push	ix
		call	bitmapand	;b is height
		pop	ix
		pop	bc
		
		pop	hl
		call	bitmapor
		ret

drawinventory6:	ld	a,(flags6)
		jr	dinv3_1

drawinventory3:	ld	a,(iy+asm_flag3)
dinv3_1:	and	h
		ret	z
		;jp	drawcornersol

drawcornersol:	ld	de,365fh	;lower right corner
		;jr	drawsolid

drawsolid:	call	locatebobchangepos
					;hl is src, de is dest, c is x offset
		ld	b,(hl)
		inc	hl
		push	de
		pop	ix		;ix is dest

		push	bc
		push	de		;(smaller than push ix)
		call	bitmapclear	;b is height
		pop	ix
		pop	bc

		call	bitmapor
		ret
		

bitmapand:	ld	a,c
		or	a
		jr	z,bma_even

bma_1:		push	bc
		ld	a,(hl)
		ld	b,c
bma_2:		scf
		rra
		djnz	bma_2
		and	(ix+0)
		ld	(ix+0),a
		ld	a,8
		sub	c
		ld	b,a
		ld	a,(hl)
bma_3:		or	a
		rla
		djnz	bma_3
		ld	e,a
		inc	hl
		ld	a,(hl)
		ld	b,c
bma_4:		or	a
		rra
		djnz	bma_4
		or	e
		and	(ix+1)
		ld	(ix+1),a
		ld	a,8
		sub	c
		ld	b,a
		ld	a,(hl)
bma_5:		scf
		rla
		djnz	bma_5
		and	(ix+2)
		ld	(ix+2),a
		inc	hl
		pop	bc
		ld	de,12
		add	ix,de
		djnz	bma_1
		ret


bma_even:	ld	de,12
bma_even_1:	ld	a,(ix+0)
		and	(hl)
		ld	(ix+0),a
		inc	hl
		ld	a,(ix+1)
		and	(hl)
		ld	(ix+1),a
		inc	hl
		add	ix,de
		djnz	bma_even_1
		ret

bitmapclear:	ld	a,c
		or	a
		jr	z,bmc_even

bmc_1:		push	bc
		xor	a
		ld	b,c
bmc_2:		scf
		rra
		djnz	bmc_2
		and	(ix+0)
		ld	(ix+0),a

		xor	a
		ld	(ix+1),a

		ld	a,8
		sub	c
		ld	b,a
		xor	a
bmc_5:		scf
		rla
		djnz	bmc_5
		and	(ix+2)
		ld	(ix+2),a

		pop	bc
		ld	de,12
		add	ix,de
		djnz	bmc_1
		ret


bmc_even:	ld	de,12
		xor	a
bmc_even_1:	ld	(ix+0),a
		ld	(ix+1),a
		add	ix,de
		djnz	bmc_even_1
		ret


bitmapor:	ld	a,c
		or	a
		jr	z,bmo_even

bmo_1:		push	bc
		ld	a,(hl)
		ld	b,c
bmo_2:		or	a
		rra
		djnz	bmo_2
		or	(ix+0)
		ld	(ix+0),a
		ld	a,8
		sub	c
		ld	b,a
		ld	a,(hl)
bmo_3:		or	a
		rla
		djnz	bmo_3
		ld	e,a
		inc	hl
		ld	a,(hl)
		ld	b,c
bmo_4:		or	a
		rra
		djnz	bmo_4
		or	e
		or	(ix+1)
		ld	(ix+1),a
		ld	a,8
		sub	c
		ld	b,a
		ld	a,(hl)
bmo_5:		or	a
		rla
		djnz	bmo_5
		or	(ix+2)
		ld	(ix+2),a
		inc	hl
		pop	bc
		ld	de,12
		add	ix,de
		djnz	bmo_1
		ret


bmo_even:	ld	de,12
bmo_even_1:	ld	a,(ix+0)
		or	(hl)
		ld	(ix+0),a
		inc	hl
		ld	a,(ix+1)
		or	(hl)
		ld	(ix+1),a
		inc	hl
		add	ix,de
		djnz	bmo_even_1
		ret

walktopoint:	
wtp_loop:
		ld	de,(manxpos)
		call	_cphlde
		ret	z

		ld	a,(manxpos)
		cp	l
		jr	z,wtp_y
		jr	c,wtp_right
		dec	a
		ld	(manxpos),a
		ld	d,0
		jr	wtp_y
wtp_right:	inc	a
		ld	(manxpos),a
		ld	d,2
wtp_y:		ld	a,(manypos)
		cp	h
		jr	z,wtp_dolp
		jr	c,wtp_down
		dec	a
		ld	d,1
		ld	(manypos),a
		jr	wtp_dolp
wtp_down:	inc	a
		ld	d,3
		ld	(manypos),a

wtp_dolp:	ld	a,d
		ld	(mandir),a
		push	hl
		call	UpdateDisplay
		ld	hl,manwalkgfx
		inc	(hl)
		pop	hl
		jr	wtp_loop


cantpickup:	ld	hl,(curronum)
		push	hl
		ld	b,maleobjects_l
		ld	hl,maleobjects
cpu_lp:		ld	e,(hl)
		inc	hl
		ld	d,(hl)
		inc	hl
		ex	(sp),hl
		call	_cphlde
		ex	(sp),hl
		jr	z,cpu_2
		djnz	cpu_lp
		jr	cpu_1
cpu_2:		pop	hl
		ld	l,txt_ipreferwomen
		jp	sayman
cpu_1:		pop	hl
		ld	l,txt_icantpickthatup
		ld	a,(manxpos)
		cp	20
		jp	c,sayman
		cp	76
		jp	nc,sayman
		ld	l,txt_icantpickthatup_wide
		jp	sayman

maleobjects:	defw	0001h		;sleeping man
		defw	0004h		;bartender
		defw	0101h		;laughing man
		defw	0601h		;shopkeeper
		defw	0700h		;petrol man
maleobjects_l	equ	5		;#of

cantdothat:	ld	a,(currverb)
		cp	VERB_UseMGlass
		jr	nz,cdt_notmglass

		ld	l,txt_howbig_notwide
		ld	a,(manxpos)
		cp	25
		jr	c,sayman_
		cp	76
		jr	nc,sayman_
		ld	l,txt_howbig
		jr	sayman_

cdt_notmglass:	ld	l,txt_icantdothat
		ld	a,(manxpos)
		cp	25
		jr	c,sayman_
		cp	76
		jr	nc,sayman_
		ld	l,txt_icantdothat_wide
sayman_:	jp	sayman

additem:	push	af
		push	hl
		ld	a,(ilistnumitems)
		ld	hl,ilistdata
		ld	e,a
		add	a,a
		add	a,e
		ld	e,a
		ld	d,0
		add	hl,de
		pop	de
		ld	(hl),e
		inc	hl
		ld	(hl),d
		inc	hl
		pop	af
		ld	(hl),a
		ld	hl,ilistnumitems
		inc	(hl)
		ret

clearitems:     xor	a
		ld	(ilistnumitems),a
		ret

normalchoice:	xor	a
		ld	(ilistcurr),a
		set	flag2_dispitemlist,(iy+asm_flag2)
nch_lp:		call	UpdateDisplay
		in	a,(3)
		bit	3,a
		jr	z,nch_on
		bit	flag1_KeyPressed,(iy+asm_flag1)
		jr	nz,nch_release
		set	flag1_KeyPressed,(iy+asm_flag1)
		ld	a,feh
		out	(1),a
		in	a,(1)
		cp	f7h
		jr	z,nch_up
		cp	feh
		jr	z,nch_down
		call	Check2nd
		jr	z,nch_2nd
		res	flag1_KeyPressed,(iy+asm_flag1)
		jr	nch_lp

nch_release:	ld	bc,ff01h
		ld	a,0
		out	(1),a
		in	a,(1)
		out	(c),b
		cp	ffh
		jr	nz,nch_lp
		res	flag1_KeyPressed,(iy+asm_flag1)
		jr	nch_lp

nch_up:		ld	a,(ilistcurr)
		or	a
		jr	z,nch_lp
		dec	a
		ld	(ilistcurr),a
		jr	nch_lp

nch_down:	ld	a,(ilistcurr)
		inc	a
		ld	b,a
		ld	a,(ilistnumitems)
		cp	b
		jr	z,nch_lp
		ld	a,b
		ld	(ilistcurr),a
		jr	nch_lp

nch_2nd:	res	flag2_dispitemlist,(iy+asm_flag2)
		ld	a,(ilistcurr)
		ld	e,a
		add	a,a
		add	a,e
		ld	d,0
		ld	e,a
		ld	hl,ilistdata
		add	hl,de
		push	hl
		call	_ldHLind
		call	sayman
		pop	hl
		inc	hl
		inc	hl
		ld	a,(hl)	;get id
		or	a	;reset z flag
		ret

nch_on:		res	flag2_dispitemlist,(iy+asm_flag2)
		ret		;assume z


unpacktext:	ld	a,l
		rlca
		rlca
		rlca
		rlca
		and	fh
		ld	h,a
		ld	a,fh
		and	l
		ld	l,a

		ld	a,(currtextbank)
		cp	h
		jr	z,uptx_bankok

		push	hl
		ld	a,h
		inc	a		;get past objectnames ptr
		ld	hl,(textaddress)
		call	pointhlind_add	;hl is start of packed bank
		ld	de,textunpackbuffer
		call	Unpack
		pop	hl

uptx_bankok:	ld	a,l
		ld	hl,textunpackbuffer
		call	pointhlind_add
		ret

setonzresonnz:	push	af
		ld	a,1
		jr	z,szrnz_1
		xor	a
szrnz_1:	ld	(hl),a
		pop	af
		ret

UDDelay5:	ld	b,5
		jr	UDDelay

UDDelay16:	ld	b,16

UDDelay:	push	bc
		call	UpdateDisplay
		pop	bc
		djnz	UDDelay
		ret

vputspace:	ld	a,20h
		jp	_vputmap

forcemangfxdelay:		;inputs in l and b
		ld	(forcemangfx),hl
		set	flag1_forcemangfx,(iy+asm_flag1)
		call	UDDelay
		res	flag1_forcemangfx,(iy+asm_flag1)
		ret

setposanddir:	ld	(manxpos),hl
		ld	(mandir),a
		ret

locatebobchangepos:
		push	de			;locatebob
		ld	a,l
		ld	hl,(bobsaddress)
		call	pointhlind_add
		pop	de

		ld	c,(hl)			;changepos
		inc	hl
		ld	b,(hl)
		inc	hl
		ex	de,hl
		or	a
		sbc	hl,bc
		ex	de,hl

		push	hl
		push	de
		ld	hl,PLOTSSCREEN-12
		ld	b,d
		ld	de,12
		inc	b
lbcp_lp1:	add	hl,de
		djnz	lbcp_lp1
		pop	de
		ld	a,e
		srl	a
		srl	a
		srl	a
		ld	c,a
		ld	b,0
		add	hl,bc
		ld	a,e
		and	111b
		ld	c,a
		ld	e,l
		ld	d,h
		pop	hl	
		ret		;hl is src, de is dest, c is x offset


pointhlind_add:	push	hl
		call	_A2POINTHLIND
		pop	de
		add	hl,de
		ret

copy24spaces:	ld	l,e
		ld	h,d
		ld	a,20h
		ld	(hl),a
		inc	de
		ld	bc,24
		ldir
		ret

LoadObjectFlags:
		ld	a,(de)
		ld	b,a
		inc	de
		ld	hl,(currobjs)
lofl_1:		ld	a,(de)
		ld	(hl),a
		push	de
		ld	de,objSIZE
		add	hl,de
		pop	de
		inc	de
		djnz	lofl_1
		ret

Check2nd:	ld	a,bfh
		out	(1),a
		in	a,(1)
		cp	dfh
		ret

;invobject_off:	xor	a
;		jr	invobject_on_1
;
;invobject_on:	ld	a,1
;invobject_on_1:	ld	d,0
;		ld	hl,objsInventory
;		add	hl,de
;		ld	(hl),a
;		ld	hl,flags6
;		ret

;--------------------------------------------------------------------------

mantalkgfxarray:
		defb	gfx_manlefttalk
		defb	gfx_manback
		defb	gfx_manrighttalk
		defb	gfx_manfronttalk


filenamez:	defm	5,"ZSTRANDZ"

txt_space:	defm	" ",0	;before & after each text

;txt_youarecarrying:
;		defm	"Inventory:",0


txt_hahaha:	defm	"Ha! Ha! Ha!",0
txt_hohoho:	defm	"      Ho! Ho!",0


jokearray:	defb	txt_joke1a
		defb	txt_nowhat
		defb	txt_joke1b

		defb	txt_joke2a
		defb	txt_beatsme
		defb	txt_joke2b

		;defb	txt_joke3a
		;defb	txt_nowhat
		;defb	txt_joke3b

		defb	txt_joke4a
		defb	txt_notellit
		defb	txt_joke4b

		defb	txt_joke5a
		defb	txt_nowhatabouthim
		defb	txt_joke5b

inventorynames:
		defb	txt_cardofortune
		defb	txt_flower
		defb	txt_rope
		defb	txt_mug
		defb	txt_coins
		defb	txt_cheese
		defb	txt_magnifyingglass
		defb	txt_branch
		defb	txt_birdcage
		defb	txt_fishingrod
		defb	txt_mouse
		defb	txt_key

		defb	txt_nothing

wooftable:	defm	55,30
		defb	txt_woof1
		defm	35,30
		defb	txt_woof2
		defm	15,30
		defb	txt_woof3

sinustable:	defm	26h,27h,27h,26h,26h,25h,25h,26h

sinusbackground:
		defm	%11110000
		defm	%11111100
		defm	%11111110
		defm	%11111111
		defm	%11111111
		defm	%11111111
		defm	%11111110
		defm	%11111100
		defm	%11110000
		defm	%11100000
		defm	%11000000
		defm	%10000000
		defm	%10000000
		defm	%10000000
		defm	%11000000
		defm	%11100000


normalwalktos:	defm	06,ROOM_Bar
		defw	OSBar_Enter

		defm	00,ROOM_OSGirl
		defw	OSBar_Enter
		defm	01,ROOM_OSGirl
		defw	OSCott_Enter

		defm	01,ROOM_OSCott
		defw	OSGirl_Enter
		defm	05,ROOM_OSCott
		defw	Pond_Enter

		defm	00,ROOM_OSShop
		defw	Yard_Enter
		defm	01,ROOM_OSShop
		defw	Shop_Enter
		defm	02,ROOM_OSShop
		defw	OSBar_Enter
		defm	03,ROOM_OSShop
		defw	Petrol_Enter

		defm	01,ROOM_Pond
		defw	OSCott_Enter
		defm	03,ROOM_Pond
		defw	Petrol_Enter

		defm	00,ROOM_Shop
		defw	OSShop_Enter

		defm	01,ROOM_Petrol
		defw	OSShop_Enter
		defm	04,ROOM_Petrol
		defw	Pond_Enter

		defm	04,ROOM_Yard
		defw	OSShop_Enter

		defm	01,ROOM_Girl
		defw	OSGirl_Enter

normalwalktos_l	equ	($-normalwalktos)/4


objFlag		equ	0
objX		equ	1
objY		equ	2
objUp		equ	3
objDown		equ	4
objLeft		equ	5
objRight	equ	6
objManX		equ	7
objManY		equ	8
objManDir	equ	9
objText		equ	10
objLookAt	equ	11
objSIZE		equ	12

		;	f,xx,yy,up,dn,lt,rt,mx,my,md		 id
		;	---------------------------------------------
objsInventory:	;defm	0,00,00,-1,-1,-1,-1,00,00,00		;00
		;defb	0	;this is just a dummy to
		;defb	0	;avoid inventory object #0

		defm	0,59,06,-1,08,07,11,00,00,00		;00	;12
		defb	txt_cardofortune
		defb	txt_cardofortune_la

		defm	0,08,23,-1,-1,04,02,00,00,00		;01
		defb	txt_flower
		defb	txt_invflower_la

		defm	0,20,30,-1,-1,01,03,00,00,00		;02
		defb	txt_rope
		defb	txt_boringla

		defm	0,34,23,-1,10,02,05,00,00,00		;03
		defb	txt_mug
		defb	txt_mug_la

		defm	0,08,22,-1,-1,06,01,00,00,00		;04
		defb	txt_coins
		defb	txt_coins_la

		defm	0,35,41,03,-1,03,10,00,00,00		;05
		defb	txt_cheese
		defb	txt_invcheese_la

		defm	0,08,19,-1,-1,-1,04,00,00,00		;06
		defb	txt_magnifyingglass
		defb	txt_boringla

		defm	0,49,26,00,-1,10,08,00,00,00		;07
		defb	txt_branch
		defb	txt_itsmadeofwood

		defm	0,67,31,11,-1,07,09,00,00,00		;08
		defb	txt_birdcage
		defb	txt_birdcage_la

		defm	0,86,29,11,-1,08,-1,00,00,00		;09
		defb	txt_fishingrod
		defb	txt_fishingrod_la

		defm	0,35,41,03,05,05,07,00,00,00		;10
		defb	txt_mouse
		defb	txt_invmouse_la

		defm	0,80,06,-1,09,00,-1,00,00,00		;11
		defb	txt_key
		defb	txt_boringla

objsEmptyInv:	defm	1,48,32,-1,-1,-1,-1,00,00,00		;00
		defb	txt_nothing
		defb	0

;----------------------------------------------------------------------------


Bar_Enter:	ld	a,ROOM_Bar
		ld	hl,Bar_Objects
		call	LoadRoom
		ld	hl,61*256+42
		ld	a,1
		call	setposanddir

Bar_Loop:	call	UDHandleInput
		jr	z,Bar_Loop
		cp	HI_Quit
		ret	z
		cp	HI_TalkTo
		jr	z,Bar_TalkTo
		cp	HI_PickUp
		jp	z,Bar_PickUp
		cp	HI_Use
		jp	z,Bar_Use
		;cp	HI_GiveTo
		;jp	z,Bar_GiveTo
		cp	HI_UseWith
		jp	z,Bar_UseWith
Bar_retnoverb:	xor	a
		ld	(currverb),a
		jr	Bar_Loop

Bar_TalkTo:	ld	a,(curronum)
		cp	01h
		jr	z,Bar_tt_sm
		cp	04h
		jr	z,Bar_tt_bt
		jr	Bar_retnoverb

Bar_tt_sm:	call	walktocurrobj
		ld	l,txt_excuseme
		call	sayman
		jr	Bar_retnoverb

Bar_tt_bt:	call	walktocurrobj
		ld	l,txt_excuseme
		call	sayman
		ld	l,txt_yeahboy
		call	saybartender

Bar_ttbt_lp:	call	clearitems
		ld	l,txt_howsbusiness
		ld	a,1
		call	additem
		ld	l,txt_gimmeabeer
		ld	a,2
		call	additem
		ld	l,txt_wellseeyoulater
		ld	a,3
		call	additem
		call	normalchoice
		ret	z
		dec	a	;cp 1
		jr	z,Bar_ttbt_bus
		dec	a	;cp 2
		jr	z,Bar_ttbt_beer
		dec	a	;cp 3
		jr	z,Bar_ttbt_end

Bar_ttbt_bus:	ld	l,txt_bartenderbusiness
		call	saybartender
		jr	Bar_ttbt_lp

Bar_ttbt_beer:	ld	l,txt_reply_gimmebeer
		call	saybartender

Bar_ttbeer_lp:	call	clearitems
		ld	l,txt_butiamnotminor
		ld	a,1
		call	additem
		ld	l,txt_awsucks
		ld	a,2
		call	additem
		call	normalchoice
		ret	z
		dec	a	;cp 1
		jr	z,Bar_ttbeer_notminor
		dec	a	;cp 2
		jr	z,Bar_ttbt_lp

Bar_ttbeer_notminor:
		ld	l,txt_re_notminor
		call	saybartender

Bar_ttprove_lp:	call	clearitems
		ld	a,(flags4)
		bit	flag4_said_driverslicence,a
		jr	nz,Bar_ttprove_no1
		ld	l,txt_provenotminor1
		ld	a,1
		call	additem
Bar_ttprove_no1:
		ld	l,txt_provenotminor2
		ld	a,2
		call	additem
		call	normalchoice
		ret	z
		dec	a	;cp 1
		jr	nz,Bar_ttbt_lp

Bar_ttprove_dl:	ld	l,txt_re_driverslicence
		call	saybartender
		ld	l,txt_nodriverslicence
		call	sayman
		ld	l,txt_renodriverslicence
		call	saybartender
		ld	hl,flags4
		set	flag4_said_driverslicence,(hl)
		jp	Bar_ttbt_lp

Bar_ttbt_end:	ld	l,txt_bartenderend
		call	saybartender
Bar_retnoverb2:	jp	Bar_retnoverb

Bar_PickUp:	ld	a,(curronum)
		cp	03
		jr	z,Bar_pu_mug
		cp	07
		jr	z,Bar_pu_cheese
		cp	08
		jr	z,Bar_pu_mouse
		cp	11
		jr	z,Bar_pu_rope
		cp	12
		jr	nc,Bar_pu_cage		;12 or 13
		call	cantpickup
		jr	Bar_retnoverb2

Bar_pu_mug:	ld	l,gfx_manrightstretchup
		ld	b,5
		call	forcemangfxdelay
		set	flag3_gotmug,(iy+asm_flag3)
		ld	a,1
		ld	(objsInventory+INV_Mug*objSIZE),a
		xor	a
		ld	(Bar_Objects+03*objSIZE),a
		call	activateobject
		jr	Bar_retnoverb2
Bar_pu_cageno:
Bar_pu_cheese:	ld	l,txt_idontwantit
		call	sayman
		jr	Bar_retnoverb2

Bar_pu_mouse:	ld	a,(flags5)
		bit	flag5_cageonfloor,a
		jr	nz,Bar_pumouse_1
		ld	l,txt_cantpickupmouse
		call	sayman
		jr	Bar_retnoverb2

Bar_pumouse_1:	xor	a
		ld	(Bar_Objects+08*objSIZE),a
		inc	a
		ld	(objsInventory+INV_Mouse*objSIZE),a
		ld	hl,flags6
		set	flag6_gotmouse,(hl)
		ld	a,13	;cage on floor
		call	activateobject
Bar_retnoverb2_:
		jr	Bar_retnoverb2

Bar_pu_cage:	ld	a,(flags5)
		bit	flag5_bar_cheese,a
		jr	nz,Bar_pu_cageno
		set	flag3_gotcage,(iy+asm_flag3)
		ld	hl,flags5
		res	flag5_cageonrope,(hl)
		res	flag5_cageonfloor,(hl)
		xor	a
		ld	(Bar_Objects+12*objSIZE),a
		ld	(Bar_Objects+13*objSIZE),a
		inc	a
		ld	(objsInventory+INV_Cage*objSIZE),a
		inc	a	;ld	a,02	;mousehole
		call	activateobject
		jr	Bar_retnoverb2_

Bar_pu_rope:	ld	hl,flags5
		bit	flag5_cageonrope,(hl)
		jr	z,Bar_puro_nfall
		bit	flag5_bar_cheese,(hl)
		jr	z,Bar_puro_nterr
		ld	a,txt_mouseterrified
		ld	(Bar_Objects+08*objSIZE+objLookAt),a
Bar_puro_nterr:	res	flag5_cageonrope,(hl)
		set	flag5_cageonfloor,(hl)
		xor	a
		ld	(Bar_Objects+12*objSIZE),a
		inc	a
		ld	(Bar_Objects+13*objSIZE),a
		inc	a	;ld a,2
		call	activateobject
Bar_puro_nfall:	ld	hl,ropestate
		ld	(hl),1
		jp	Bar_uro_drop

Bar_Use:	ld	a,(curronum)
		cp	09
		jr	z,Bar_u_rope1
		cp	10
		jr	z,Bar_u_rope1
		call	cantdothat
		jp	Bar_retnoverb2
Bar_u_rope1:	ld	a,VERB_UseRope
		ld	(currverb),a
		jp	Bar_Loop

Bar_GiveTo:	;ld	a,(curronum)
		;cp	04h
		;jr	z,Bar_gt_bart
		;cp	01h
		;jr	z,Bar_gt_sleepm
		;jp	Bar_retnoverb2

Bar_gt_bart:	;ld	l,txt_nothanks
		;call	saybartender
		;jp	Bar_retnoverb2

Bar_gt_sleepm:	;ld	a,3
		;ld	(mandir),a
		;ld	l,txt_cantwakehimup
		;call	sayman
		;xor	a
		;ld	(mandir),a
		;jp	Bar_retnoverb2

Bar_UseWith:	ld	a,(currverb)
		cp	VERB_UseCheese
		jr	z,Bar_uch
		cp	VERB_UseRope
		jr	z,Bar_uro
		cp	VERB_UseCage
		jr	z,Bar_uca
Bar_uw_cdt:	call	cantdothat
		jp	Bar_retnoverb2

Bar_uch:	ld	a,(curronum)
		cp	02	;mousehole
		jr	nz,Bar_uw_cdt
		call	walktocurrobj
		ld	hl,flags5
		bit	flag5_cageonfloor,(hl)
		jr	nz,Bar_uch_cage
		res	flag3_gotcheese,(iy+asm_flag3)
		;ld	hl,flags5
		set	flag5_bar_cheese,(hl)
		xor	a
		ld	(objsInventory+INV_Cheese*objSIZE),a
		inc	a	;ld	a,1
		ld	(Bar_Objects+07*objSIZE),a
		ld	(Bar_Objects+08*objSIZE),a
Bar_uch_retnvb:	jp	Bar_retnoverb2

Bar_uch_cage:	ld	a,3
		ld	(mandir),a
		ld	l,txt_notbothcheeseandcage
		call	sayman
		jr	Bar_uch_retnvb

Bar_uro:	ld	a,(curronum)
		or	a	;painting
		jr	z,Bar_uro_p
		cp	05	;hook
		jr	z,Bar_uro_h
		jr	Bar_uw_cdt

Bar_uro_p:	call	walktocurrobj
		ld	hl,ropestate
		set	0,(hl)
		jr	Bar_uro_drop

Bar_uro_h:	call	walktocurrobj
		ld	hl,ropestate
		set	1,(hl)

Bar_uro_drop:	ld	a,(hl)
		ld	hl,Bar_Objects+09*objSIZE
		dec	a	;cp 1
		call	setonzresonnz
		ld	hl,Bar_Objects+10*objSIZE
		dec	a	;cp 2
		call	setonzresonnz
		ld	hl,Bar_Objects+11*objSIZE
		dec	a	;cp 3
		call	setonzresonnz

		xor	a
		ld	(objsInventory+INV_Rope*objSIZE),a
		res	flag3_gotrope,(iy+asm_flag3)
		jp	Bar_retnoverb2

Bar_uca:	ld	a,(curronum)
		cp	11	;rope on both
		jr	nz,Bar_uw_cdt

		call	walktocurrobj
		xor	a
		ld	(objsInventory+INV_Cage*objSIZE),a
		inc	a	;ld	a,1
		ld	(mandir),a
		ld	(Bar_Objects+12*objSIZE),a
		res	flag3_gotcage,(iy+asm_flag3)
		ld	hl,flags5
		set	flag5_cageonrope,(hl)
		jp	Bar_retnoverb2


;Bar_ObjFlags:	defm	1,1,1,1,1,1,1,0,0,0,0,0,0,0	;too many objs.

		;	f,xx,yy,up,dn,lt,rt,mx,my,md		 id
		;	---------------------------------------------
Bar_Objects:	defm	1,24,12,-1,09,09,11,36,42,01		;00
		defb	txt_painting
		defb	txt_boringla

		defm	1,14,34,09,06,-1,13,36,51,00		;01
		defb	txt_sleepingman
		defb	txt_sleepingman_la

		defm	1,51,38,12,07,13,05,46,48,01		;02
		defb	txt_mousehole
		defb	txt_mousehole_la

		defm	1,65,19,-1,11,11,04,52,41,02		;03
		defb	txt_mug
		defb	txt_mug_la

		defm	1,83,21,-1,05,03,-1,56,53,02		;04
		defb	txt_bartender
		defb	txt_bartender_la

		defm	1,85,35,04,10,02,-1,76,58,01		;05
		defb	txt_hook
		defb	txt_boringla

		defm	1,46,52,07,-1,01,10,46,60,03		;06
		defb	txt_path
		defb	0

		defm	0,49,41,02,06,08,05,46,50,01		;07
		defb	txt_cheese
		defb	txt_invcheese_la

		defm	0,44,41,13,06,01,07,44,51,01		;08
		defb	txt_mouse
		defb	txt_mouse_la

		defm	0,23,23,00,01,01,03,36,42,01		;09
		defb	txt_rope	;on painting
		defb	txt_boringla

		defm	0,83,48,05,06,02,05,76,58,01		;10
		defb	txt_rope	;on hook
		defb	txt_boringla

		defm	0,49,20,00,12,00,03,41,45,02		;11
		defb	txt_rope	;on both
		defb	txt_boringla

		defm	0,45,24,11,02,00,03,38,45,02		;12
		defb	txt_birdcage	;on rope
		defb	txt_birdcage_la

		defm	0,43,36,12,08,01,02,44,51,01		;13
		defb	txt_birdcage	;on floor
		defb	txt_birdcage_la

;----------------------------------------------------------------------------



OSBar_Enter:	ld	a,(currroom)
		push	af
		ld	a,ROOM_OSBar
		;ld	hl,OSBar_Objects
		call	LoadRoomDef
		pop	af
		cp	ROOM_OSGirl
		jr	z,OSBar_enter_2
		cp	ROOM_OSShop
		jr	z,OSBar_enter_3

OSBar_enter_1:	ld	hl,53*256+85
		ld	a,3
		call	setposanddir
		jr	OSBar_enter_ok

OSBar_enter_2:	ld	hl,53*256+85
		xor	a
		call	setposanddir
		jr	OSBar_enter_ok

OSBar_enter_3:	ld	hl,54*256+10
		ld	a,2
		call	setposanddir

OSBar_enter_ok:	ld	a,3
		ld	(osbar_manlaughcount),a
		ld	(osbar_manhahocount),a
		xor	a
		ld	(osbar_manlaughflag),a
		ld	(osbar_manhahoflag),a

OSBar_Loop:	ld	a,(osbar_manhahocount)
		dec	a
		jr	nz,OSBar_L_1
		ld	a,(osbar_manhahoflag)
		xor	1
		ld	(osbar_manhahoflag),a
		ld	a,16
OSBar_L_1:	ld	(osbar_manhahocount),a
		ld	hl,txt_hahaha
		ld	a,(osbar_manhahoflag)
		or	a
		jr	z,OSBar_L_2
		ld	hl,txt_hohoho
OSBar_L_2:	ld	(text1txt),hl
		ld	de,0a15h
		ld	(text1xpos),de
		set	flag1_Text1,(iy+asm_flag1)

		call	UDHandleInput
		jr	z,OSBar_Loop
		cp	HI_Quit
		ret	z
		cp	HI_WalkTo
		jr	z,OSBar_WalkTo
		;cp	HI_GiveTo
		;jr	z,OSBar_GiveTo
		cp	HI_TalkTo
		jr	z,OSBar_TalkTo
OSBar_retnoverb:
		xor	a
		ld	(currverb),a
		jr	OSBar_Loop

OSBar_WalkTo:	res	flag1_Text1,(iy+asm_flag1)
		ld	a,(curronum)
		or	a
		jp	z,Bar_Enter
		cp	02
		jp	z,OSGirl_Enter
		cp	03
		jp	z,OSShop_Enter
		set	flag1_Text1,(iy+asm_flag1)
		jr	OSBar_Loop

OSBar_GiveTo:	;ld	a,(curronum)
		;cp	01h
		;jr	z,OSBar_gt_laughm
		;jr	OSBar_retnoverb

OSBar_gt_laughm:
		;call	laughingmanhuh
		;ld	l,txt_nothanks
		;call	saylaughingman
		;jr	OSBar_retnoverb

OSBar_TalkTo:	ld	a,(curronum)
		cp	01
		jr	nz,OSBar_retnoverb

		call	walktocurrobj
		ld	l,txt_hello
		call	sayman
		ld	l,txt_ohhithere
		call	saylaughingmanhuh

OSBar_tt_loop:	ld	hl,(currentjokeptr)
		push	hl
		ld	l,(hl)
		call	saylaughingman

		call	clearitems
		pop	hl
		inc	hl
		ld	l,(hl)
		ld	a,1
		call	additem
		ld	a,(flags4)
		bit	flag4_said_jokessuck,a
		jr	nz,OSBar_tt_no3
		ld	a,3
		ld	l,txt_jokessuck
		call	additem
OSBar_tt_no3:	ld	a,2
		ld	l,txt_whocaresimout
		call	additem
		call	normalchoice
		ret	z
		dec	a	;cp 1
		jr	z,OSBar_tt_joke
		dec	a	;cp 2
		jr	z,OSBar_tt_leave
		;dec	a	;cp 3
		jr	OSBar_tt_suck

OSBar_tt_joke:	ld	hl,(currentjokeptr)
		inc	hl
		inc	hl
		push	hl
		ld	l,(hl)
		call	saylaughingman
		pop	hl
		inc	hl
		ld	a,(currentjoke)
		inc	a
		cp	4		;number of jokes
		jr	nz,OSBar_tt_morejokes
		xor	a
		ld	hl,jokearray
OSBar_tt_morejokes:
		ld	(currentjoke),a
		ld	(currentjokeptr),hl
		ld	l,txt_hahahaanyway
		call	saylaughingman
		jr	OSBar_tt_loop

OSBar_tt_leave:	ld	l,txt_wellseeyoulater
		call	saylaughingmanhuh
		jp	OSBar_retnoverb

OSBar_tt_suck:	ld	hl,flags4
		set	flag4_said_jokessuck,(hl)
		ld	l,txt_re_jokessuck
		call	saylaughingmanhuh
		jp	OSBar_tt_loop


;----------------------------------------------------------------------------



OSGirl_Enter:	ld	a,(currroom)
		push	af
		ld	a,ROOM_OSGirl
		call	LoadRoomDef
		ld	de,OSGirl_ObjFlags
		call	LoadObjectFlags
		pop	af
		cp	ROOM_OSCott
		jr	nz,OSGirl_e_notfromcott
		ld	hl,33*256+34
		ld	a,3
		call	setposanddir
		jr	OSGirl_Loop

OSGirl_e_notfromcott:
		cp	ROOM_Girl
		jr	nz,OSGirl_e_notfromgirl
		ld	hl,45*256+72
		ld	a,0
		call	setposanddir
		jr	OSGirl_Loop

OSGirl_e_notfromgirl:
		ld	hl,53*256+10
		ld	a,2
		call	setposanddir

OSGirl_Loop:	call	UDHandleInput
		jr	z,OSGirl_Loop
		cp	HI_Quit
		ret	z
		cp	HI_PickUp
		jr	z,OSGirl_PickUp
		cp	HI_Use
		jr	z,OSGirl_Use
		cp	HI_UseWith
		jp	z,OSGirl_UseWith
		cp	HI_WalkTo
		jr	z,OSGirl_WalkTo
OSGirl_retnoverb:
		xor	a
		ld	(currverb),a
		jr	OSGirl_Loop

OSGirl_WalkTo:	ld	a,(curronum)
		cp	03	;door
		jr	nz,OSGirl_Loop
		bit	flag2_girlsdooropen,(iy+asm_flag2)
		jp	nz,Girl_Enter
		jr	OSGirl_Loop

OSGirl_PickUp:	ld	a,(curronum)
		cp	02h
		jr	z,OSGirl_pu_flower
		cp	01h		;prevent from writing above display
		call	nz,cantpickup
		jr	OSGirl_retnoverb

OSGirl_pu_flower:
		ld	l,gfx_manrightstretch
		ld	b,5
		call	forcemangfxdelay
		set	flag1_osgirl_flowertaken,(iy+asm_flag1)
		set	flag3_gotflower,(iy+asm_flag3)
		ld	a,1
		ld	(objsInventory+INV_Flower*objSIZE),a
		xor	a
		ld	(OSGirl_ObjFlags+1+02),a
		call	activateobject
		ld	de,OSGirl_ObjFlags
		call	LoadObjectFlags
		jr	OSGirl_retnoverb

OSGirl_Use:	ld	a,(curronum)
		cp	03
		jr	z,OSGirl_u_door
		call	cantdothat
		jr	OSGirl_retnoverb

OSGirl_u_door:	bit	flag2_girlsdooropen,(iy+asm_flag2)
		jr	nz,OSGirl_retnoverb

		ld	hl,txt_illknock
		call	sayman
		ld	l,gfx_manrightstretchup
		ld	(forcemangfx),hl

		ld	b,2
OSGirl_udoor_0:	push	bc
		set	flag1_forcemangfx,(iy+asm_flag1)
		ld	b,4
		call	UDDelay
		res	flag1_forcemangfx,(iy+asm_flag1)
		;ld	b,5
		call	UDDelay5
		pop	bc
		djnz	OSGirl_udoor_0

		ld	hl,45*256+62
		call	walktopoint
		ld	a,2
		ld	(mandir),a
		xor	a
		ld	(manwalkgfx),a

		;ld	b,14
		call	UDDelay16

		set	flag2_girlsdooropen,(iy+asm_flag2)

		ld	hl,2a50h
		ld	(girlxpos),hl
		set	flag2_displaygirl,(iy+asm_flag2)

		ld	l,txt_hello
		call	saygirl

		ld	hl,flags5

		bit	flag5_seengirlonce,(hl)
		jr	nz,OSGirl_udoor_2

		set	flag5_manstaring,(hl)
		push	hl

		ld	b,20
		call	UDDelay

		pop	hl
		res	flag5_manstaring,(hl)
OSGirl_udoor_2:
		call	clearitems
		ld	b,3
		ld	l,txt_mumble1
OSGirl_udoor_1:	push	bc
		push	hl
		ld	a,1
		call	additem
		pop	hl
		pop	bc
		inc	l
		djnz	OSGirl_udoor_1

		ld	hl,flags5
		bit	flag5_seengirlonce,(hl)
		set	flag5_seengirlonce,(hl)
		jr	z,OSGirl_udoor_3

		ld	l,txt_askinggirlout
		ld	a,2
		call	additem

OSGirl_udoor_3:
		call	normalchoice
		ret	z
		cp	2
		jr	nz,OSGirl_udoor_4

		ld	l,txt_re_askinggirlout
		call	saygirl
OSGirl_udoor_4:
		
		res	flag2_displaygirl,(iy+asm_flag2)
		res	flag2_girlsdooropen,(iy+asm_flag2)

		ld	b,7
		call	UDDelay

		ld	a,3
		ld	(mandir),a
		ld	l,txt_afterseeinggirl
		call	sayman
		ld	a,2
		ld	(mandir),a
OSGirl_retnoverb_:
		jp	OSGirl_retnoverb


OSGirl_UseWith:	ld	a,(currverb)
		cp	VERB_UseMouse
		jr	nz,OSGirl_uw_cdt
		ld	a,(curronum)
		cp	04	;window
		jr	nz,OSGirl_uw_cdt

		ld	hl,54*256+86
		call	walktopoint

		ld	l,gfx_manrightstretchup
		ld	b,9
		call	forcemangfxdelay

		call	walktocurrobj

		ld	hl,2a50h
		ld	(girlxpos),hl
		ld	l,txt_helpamouse
		call	saygirl

		set	flag2_girlsdooropen,(iy+asm_flag2)

		set	flag2_displaygirl,(iy+asm_flag2)
		call	UpdateDisplay
		ld	a,40h
		ld	(girlxpos),a
		call	UpdateDisplay
		ld	a,30h
		ld	(girlxpos),a
		call	UpdateDisplay
		ld	a,20h
		ld	(girlypos),a
		call	UpdateDisplay
		res	flag2_displaygirl,(iy+asm_flag2)

		xor	a
		ld	(objsInventory+INV_Mouse*objSIZE),a
		ld	hl,flags6
		res	flag6_gotmouse,(hl)

		jr	OSGirl_retnoverb_

OSGirl_uw_cdt:	call	cantdothat
		jr	OSGirl_retnoverb_


OSGirl_ObjFlags:
		defb	5
		defm	1,1,1,1,1		


;----------------------------------------------------------------------------



OSCott_Enter:	ld	a,(currroom)
		push	af
		ld	a,ROOM_OSCott
		call	LoadRoomDef
		call	OSCott_LoadOF
		pop	af
		cp	ROOM_Pond
		jr	z,OSCott_e_2
		cp	ROOM_Cott
		jr	z,OSCott_e_3

OSCott_e_1:	ld	hl,52*256+35
		ld	a,1
		call	setposanddir
		jr	OSCott_e_ok

OSCott_e_2:	ld	hl,50*256+9
		ld	a,2
		call	setposanddir
		jr	OSCott_e_ok

OSCott_e_3:	ld	hl,48*256+79
		ld	a,3
		call	setposanddir
		;jr	OSCott_e_ok

OSCott_e_ok:
OSCott_Loop:	call	UDHandleInput
		jr	z,OSCott_Loop
		cp	HI_Quit
		ret	z
		cp	HI_WalkTo
		jr	z,OSCott_WalkTo
		cp	HI_PickUp
		jr	z,OSCott_PickUp
		cp	HI_Use
		jp	z,OSCott_Use
OSCott_retnoverb:
		xor	a
		ld	(currverb),a
		jr	OSCott_Loop

OSCott_WalkTo:	ld	a,(curronum)
		or	a
		jr	nz,OSCott_Loop
		
OSCott_wt_door:	ld	a,(flags5)
		bit	flag5_branchlit,a
		jp	nz,Cott_Enter
		ld	l,txt_notwithoutlight
		call	sayman
		jr	OSCott_Loop

OSCott_PickUp:	ld	a,(curronum)
		cp	06h
		jr	z,OSCott_pu_rope
		cp	01h	;prevent writing outside the display
		call	nz,cantpickup
		jr	OSCott_retnoverb

OSCott_pu_rope:	ld	l,gfx_manrightstretch
		ld	b,5
		call	forcemangfxdelay
		set	flag2_oscott_ropetaken,(iy+asm_flag2)
		set	flag3_gotrope,(iy+asm_flag3)
		ld	a,1
		ld	(objsInventory+INV_Rope*objSIZE),a
		ld	a,03
		call	activateobject
		xor	a
		ld	(OSCott_ObjFlags+1+06),a
		call	OSCott_LoadOF
		jr	OSCott_retnoverb

OSCott_Use:	ld	a,(curronum)
		cp	03h
		jr	z,OSCott_u_well
		call	cantdothat
		jr	OSCott_retnoverb

OSCott_u_well:	bit	flag2_hasusedwell,(iy+asm_flag2)
		jr	z,OSCott_uwell_0
		ld	l,txt_ithinkibrokeit
		call	sayman
		jp	OSCott_retnoverb

OSCott_uwell_0:	ld	l,gfx_manrightstretch
		ld	b,5
		call	forcemangfxdelay
		ld	b,4
		call	UDDelay
		set	flag1_forcemangfx,(iy+asm_flag1)
		;ld	b,5
		call	UDDelay5
		res	flag1_forcemangfx,(iy+asm_flag1)
		ld	l,txt_afterusingwell
		call	sayman
		ld	a,1
		ld	(OSCott_ObjFlags+1+06),a
		call	OSCott_LoadOF
		set	flag2_hasusedwell,(iy+asm_flag2)
		;ld	a,txt_verywell
		;ld	(OSCott_Objects+03h*objSIZE+objLookAt),a
		jp	OSCott_retnoverb

OSCott_LoadOF:	ld	de,OSCott_ObjFlags
		jp	LoadObjectFlags

OSCott_ObjFlags:
		defb	7
		defm	1,1,1,1,1,1,0

;----------------------------------------------------------------------------



OSShop_Enter:	ld	a,(currroom)
		push	af
		ld	a,ROOM_OSShop
		;ld	hl,OSShop_Objects
		call	LoadRoomDef
		pop	af
		cp	ROOM_Shop
		jr	z,OSShop_e_2
		cp	ROOM_Petrol
		jr	z,OSShop_e_3
		cp	ROOM_Yard
		jr	z,OSShop_e_4

OSShop_e_1:	ld	hl,54*256+87
		xor	a
		call	setposanddir
		jr	OSShop_e_ok

OSShop_e_2:	ld	hl,53*256+14
		ld	a,3
		call	setposanddir
		jr	OSShop_e_ok

OSShop_e_3:	ld	hl,54*256+10
		ld	a,2
		call	setposanddir
		jr	OSShop_e_ok

OSShop_e_4:	ld	hl,53*256+66
		ld	a,3
		call	setposanddir
		;jr	OSShop_e_ok

OSShop_e_ok:
OSShop_Loop:	call	UDHandleInput
		jr	z,OSShop_Loop
		cp	HI_Quit
		ret	z
OSShop_retnoverb:
		xor	a
		ld	(currverb),a
		jr	OSShop_Loop


;----------------------------------------------------------------------------


Pond_Enter:	ld	a,(currroom)
		push	af
		ld	a,ROOM_Pond
		call	LoadRoomDef
		call	Pond_SetCampfireName
		pop	af
		cp	ROOM_Petrol
		jr	nz,Pond_e_1

		ld	hl,51*256+43
		ld	a,1
		call	setposanddir
		jr	Pond_e_ok

Pond_e_1:	ld	hl,50*256+86
		xor	a
		call	setposanddir
		;jr	Pond_e_ok

Pond_e_ok:
Pond_Loop:	call	UDHandleInput
		jr	z,Pond_Loop
		cp	HI_Quit
		ret	z
		cp	HI_UseWith
		jr	z,Pond_UseWith
Pond_retnoverb:
		xor	a
		ld	(currverb),a
		jr	Pond_Loop

Pond_UseWith:	ld	a,(currverb)
		cp	VERB_UseFRod
		jp	z,Pond_ufr
		cp	VERB_UseBranch
		jp	z,Pond_ubra
		cp	VERB_UseMGlass
		jr	z,Pond_umg
		cp	VERB_UseMug
		jr	nz,Pond_uw_no
		ld	a,(curronum)
		or	a	;woodpile
		jr	nz,Pond_uw_no

		call	walktocurrobj

		ld	a,(campfirestate)
		or	a
		jr	nz,Pond_uw_empty	;already done it

		ld	l,gfx_manrightstretch
		ld	b,5
		call	forcemangfxdelay
		ld	l,txt_aftermugonwoodpile
		call	sayman
		ld	a,txt_itsempty
		ld	(objsInventory+INV_Mug*objSIZE+objLookAt),a
		ld	a,1
		ld	(campfirestate),a
		jr	Pond_retnoverb

Pond_uw_no:	call	cantdothat
		jr	Pond_retnoverb

Pond_uw_empty:	ld	l,txt_itsempty
		call	sayman
		jr	Pond_retnoverb

Pond_umg:	ld	a,(curronum)
		or	a	;woodpile
		jr	nz,Pond_uw_no

		call	walktocurrobj

		ld	a,(campfirestate)
		cp	2	;already done it
		jr	z,Pond_umg_already

		ld	l,gfx_manrightstretch
		ld	b,5
		call	forcemangfxdelay

		ld	a,(campfirestate)
		or	a
		ld	l,txt_usemglass_fail
		call	nz,Pond_umg_doit
		call	sayman
		jr	Pond_u_retnvb

Pond_umg_already:
		call	cantdothat	;will say "how big"
Pond_u_retnvb:	jp	Pond_retnoverb

Pond_umg_doit:	ld	a,2
		ld	(campfirestate),a
		call	Pond_SetCampfireName
		;ld	a,txt_campfire
		;ld	(Pond_Objects+00*objSIZE+objText),a
		ld	l,txt_usemglass_succeed
		;ld	(Pond_Objects+00*objSIZE+objLookAt),a
		;ld	l,a
		ret		;l contains what to say

Pond_ubra:	ld	a,(curronum)
		or	a	;woodpile
		jr	nz,Pond_uw_no
		ld	a,(campfirestate)
		cp	2
		jr	nz,Pond_uw_no
		call	walktocurrobj
		ld	l,gfx_manrightstretch
		ld	b,5
		call	forcemangfxdelay
		ld	hl,flags5
		set	flag5_branchlit,(hl)
		jr	Pond_u_retnvb

Pond_ufr:	ld	a,(curronum)
		cp	02
		jr	nz,Pond_uw_no
		call	walktocurrobj
		ld	hl,flags6
		set	flag6_isfishing,(hl)
		ld	b,30
		call	UDDelay
		ld	a,1
		ld	(objsInventory+INV_Key*objSIZE),a
		ld	hl,flags6
		res	flag6_isfishing,(hl)
		bit	flag6_gotkey,(hl)
		jr	nz,Pond_u_retnvb
		set	flag6_gotkey,(hl)
		ld	l,txt_gotkey
		call	sayman
		jr	Pond_u_retnvb

Pond_SetCampfireName:
		ld	a,(campfirestate)
		cp	2
		ret	nz
		ld	hl,defobjlocation+00*objSIZE+objText
		ld	(hl),txt_campfire
		inc	hl
		ld	(hl),txt_usemglass_succeed	;cool uhhuhhuh
		ret

;----------------------------------------------------------------------------



Shop_Enter:	ld	a,ROOM_Shop
		;ld	hl,Shop_Objects
		call	LoadRoomDef
		call	Shop_LoadOF
		ld	hl,51*256+44
		ld	a,1
		call	setposanddir

Shop_Loop:	call	UDHandleInput
		jr	z,Shop_Loop
		cp	HI_Quit
		ret	z
		cp	HI_PickUp
		jr	z,Shop_PickUp
		cp	HI_TalkTo
		jp	z,Shop_TalkTo
		cp	HI_UseWith
		jp	z,Shop_UseWith
		;cp	HI_GiveTo
		;jp	z,Shop_GiveTo
Shop_retnoverb:
		xor	a
		ld	(currverb),a
		jr	Shop_Loop

Shop_PickUp:	ld	a,(curronum)
		cp	02
		jr	z,Shop_pu_cheese
		cp	03	;first sellable item
		jr	nc,Shop_pu_item
Shop_cantpickup:
		call	cantpickup
		jr	Shop_retnoverb

Shop_pu_cheese:	ld	a,(flags4)
		bit	flag4_cheesetaken,a
		jr	nz,Shop_pu_cheese_1
		ld	l,txt_takingthecheese
		call	sayman
		ld	l,txt_helpyourself
		call	sayshopkeeper
		set	flag3_gotcheese,(iy+asm_flag3)
		ld	hl,flags4
		set	flag4_cheesetaken,(hl)
		ld	a,1
		ld	(objsInventory+INV_Cheese*objSIZE),a
		jr	Shop_retnoverb

Shop_pu_cheese_1:
		ld	l,txt_nomorecheese
		call	sayman
		jr	Shop_retnoverb

Shop_pu_item:	bit	flag3_gotcoins,(iy+asm_flag3)
		jr	z,Shop_pu_cantafford
		cp	06			;magnifying glass
		jr	nz,Shop_pu_cantafford

		ld	l,txt_idlikethismagglass
		call	sayman
		ld	l,txt_thatllbe3coins
		call	sayshopkeeper
		ld	l,txt_hereyougo
		call	sayman
		set	flag2_shopkeeperstretch,(iy+asm_flag2)
		ld	b,10
		call	UDDelay
		res	flag2_shopkeeperstretch,(iy+asm_flag2)
		set	flag3_gotmglass,(iy+asm_flag3)
		res	flag3_gotcoins,(iy+asm_flag3)
		xor	a
		ld	(Shop_ObjFlags+1+06),a
		ld	(objsInventory+INV_Coins*objSIZE),a
		inc	a
		ld	(objsInventory+INV_MGlass*objSIZE),a
		;ld	a,01
		call	activateobject
		call	Shop_LoadOF
		ld	l,txt_pleasuremakingbusiness
		call	sayshopkeeper
		jp	Shop_retnoverb

Shop_pu_cantafford:
		ld	l,txt_icantaffordthat
		call	sayman
		jp	Shop_retnoverb

Shop_TalkTo:	ld	a,(curronum)
		cp	01
		jp	nz,Shop_retnoverb

		call	walktocurrobj
		ld	l,txt_excuseme
		call	sayman
		ld	l,txt_howcanihelpyou
		call	sayshopkeeper

Shop_tt_lp:	call	clearitems
		ld	a,(flags4)
		ld	c,a
		bit	flag4_said_howsbusiness,c
		jr	nz,Shop_tt_no1
		ld	l,txt_howsbusiness
		ld	a,1
		call	additem
Shop_tt_no1:	bit	flag4_said_imighthavesomething,c
		jr	nz,Shop_tt_no2
		ld	l,txt_imighthavesomething
		ld	a,2
		call	additem
Shop_tt_no2:	ld	l,txt_wellseeyoulater
		ld	a,3
		call	additem
		call	normalchoice
		ret	z
		dec	a	;cp 1
		jr	z,Shop_tt_business
		dec	a	;cp 2
		jr	z,Shop_tt_mighthavest
		dec	a	;cp 3
		jp	z,Shop_retnoverb

Shop_tt_business:
		ld	hl,flags4
		set	flag4_said_howsbusiness,(hl)
		ld	l,txt_businessterrible
		call	sayshopkeeper
		jr	Shop_tt_lp

Shop_tt_mighthavest:
		ld	hl,flags4
		set	flag4_said_imighthavesomething,(hl)
		ld	l,txt_reply_mighthavest
		call	sayshopkeeper
		jr	Shop_tt_lp

Shop_UseWith:	ld	a,(curronum)
		cp	01
		jr	z,Shop_uw_keeper

		call	cantdothat
		jp	Shop_retnoverb

Shop_uw_keeper:
		ld	a,(currverb)
		cp	VERB_UseCoins
		jr	z,Shop_gt_coins
		cp	VERB_UseFlower
		jr	nz,Shop_gt_notflower

		ld	l,txt_reply_giveflower
		call	sayshopkeeper
		res	flag3_gotflower,(iy+asm_flag3)
		xor	a
		ld	(objsInventory+INV_Flower*objSIZE),a
		inc	a
		ld	(objsInventory+INV_Coins*objSIZE),a
		set	flag3_gotcoins,(iy+asm_flag3)
		jp	Shop_retnoverb

Shop_gt_notflower:
		ld	l,txt_notworthanything
		call	sayshopkeeper
		jp	Shop_retnoverb

Shop_gt_coins:	ld	l,txt_buyinstructions
		call	sayshopkeeper
		jp	Shop_retnoverb

Shop_LoadOF:	ld	de,Shop_ObjFlags
		jp	LoadObjectFlags

Shop_ObjFlags:	defb	9
		defm	1,1,1,1,1,1,1,1,1


;----------------------------------------------------------------------------


Petrol_Enter:	ld	a,(currroom)
		push	af
		ld	a,ROOM_Petrol
		;ld	hl,Petrol_Objects
		call	LoadRoomDef
		pop	af
		cp	ffh
		jr	z,Petrol_e_init
		cp	ROOM_Pond
		jr	z,Petrol_e_1

		ld	hl,53*256+84
		xor	a
		call	setposanddir
		jr	Petrol_e_ok

Petrol_e_init:	ld	hl,46*256+48
		ld	a,3
		call	setposanddir
		ld	l,txt_idbettertank
		call	sayman				;UNCOMMENT THIS

Petrol_e_1:	ld	hl,46*256+48
		ld	a,3
		call	setposanddir
		;jr	Petrol_e_ok

Petrol_e_ok:
Petrol_Loop:	call	UDHandleInput
		jr	z,Petrol_Loop
		cp	HI_Quit
		ret	z
		cp	HI_Use
		jp	z,Petrol_Use
		cp	HI_TalkTo
		jp	z,Petrol_TalkTo
		;cp	HI_GiveTo
		;jp	z,Petrol_GiveTo
Petrol_retnoverb:
		xor	a
		ld	(currverb),a
		jr	Petrol_Loop

Petrol_Use:	ld	a,(curronum)
		cp	02
		jr	z,Petrol_u_pump
		call	cantdothat
		jr	Petrol_retnoverb

Petrol_u_pump:	ld	l,txt_whenusingpump
		call	saypetrolman
		ld	ix,defobjlocation+00*objSIZE
		call	walktoobject
		ld	hl,flags4
		set	flag4_triedtousepump,(hl)
		ld	hl,flags6
		bit	flag6_gotcard,(hl)
		jr	z,Petrol_tt_loop

		ld	l,txt_hahaivegotcard
		call	sayman
		ld	a,3
		ld	(mandir),a
		ld	l,txt_hahaivegotcard2
		call	sayman
		jp	EndSequence

Petrol_TalkTo:	ld	a,(curronum)
		or	a
		jr	nz,Petrol_retnoverb

		call	walktocurrobj
		ld	l,txt_excuseme
		call	sayman
		ld	l,txt_petrolmanhello
		call	saypetrolman

Petrol_tt_loop:	call	clearitems
		ld	a,(flags4)
		bit	flag4_triedtousepump,a
		jr	z,Petrol_tt_no2
		ld	l,txt_whycantusepump1
		;bit	flag4_said_whycantusepump,a
		;jr	z,Petrol_tt_var2
		;ld	l,txt_whycantusepump2
Petrol_tt_var2:	ld	a,2
		call	additem
Petrol_tt_no2:	ld	l,txt_howsbusiness
		ld	a,3
		call	additem
		ld	l,txt_wellseeyoulater
		ld	a,1
		call	additem
		call	normalchoice
		ret	z
		dec	a	;cp 1
		jr	z,Petrol_tt_end
		dec	a	;cp 2
		jr	z,Petrol_tt_whycant
		;dec	a	;cp 3
		jr	Petrol_tt_business

Petrol_tt_end:	call	petrolmantwyt
		jp	Petrol_retnoverb

Petrol_tt_business:
		ld	l,txt_reply_petrolbusiness
		call	saypetrolman
		jr	Petrol_tt_loop

Petrol_tt_whycant:
		ld	l,txt_reply_whynopump
		call	saypetrolman

Petrol_tt_l2:	call	clearitems
		ld	l,txt_butthatsawful
		ld	a,1
		call	additem
		ld	l,txt_heyiknowmyrights
		ld	a,1
		call	additem
		call	normalchoice
		ret	z
		;dec	a	;cp 1
		;jr	z,Petrol_tt_awful
		;dec	a	;cp 2
		;jr	Petrol_tt_sayswho

Petrol_tt_awful:
		call	petrolmantwyt
		jr	Petrol_tt_loop

Petrol_tt_sayswho:
		;ld	l,txt_saysi
		;call	saypetrolman
		;call	clearitems
		;ld	l,txt_thatswhatyouthink
		;ld	a,1
		;call	additem
		;ld	l,txt_wellseeyoulater
		;ld	a,2
		;call	additem
		;call	normalchoice
		;ret	z
		;dec	a	;cp 1
		;jr	z,Petrol_tt_twyt1
		;;dec	a	;cp 2
		;jr	Petrol_tt_end

Petrol_tt_twyt1:
		;ld	l,txt_heythatsmyline
		;call	saypetrolman
		;jp	Petrol_tt_loop

Petrol_GiveTo:	;ld	a,(curronum)
		;or	a
		;jp	nz,Petrol_retnoverb

		;ld	l,txt_nothanks
		;call	saypetrolman
		;jp	Petrol_retnoverb



;----------------------------------------------------------------------------


Yard_Enter:	ld	a,ROOM_Yard
		call	LoadRoomDef
		call	Yard_LoadOF
		ld	hl,53*256+47
		ld	a,1
		call	setposanddir

Yard_Loop:	call	UDHandleInput
		jr	z,Yard_Loop
		cp	HI_Quit
		ret	z
		cp	HI_PickUp
		jr	z,Yard_PickUp
Yard_retnoverb:	xor	a
		ld	(currverb),a
		jr	Yard_Loop

Yard_PickUp:	ld	a,(curronum)
		cp	03
		jr	z,Yard_pu_branch
		cp	01
		jr	z,Yard_pu_cage
		call	cantpickup
		jr	Yard_retnoverb

Yard_pu_branch:	set	flag3_gotbranch,(iy+asm_flag3)
		xor	a
		ld	(Yard_ObjFlags+1+03),a
		call	Yard_LoadOF
		ld	a,1
		ld	(objsInventory+INV_Branch*objSIZE),a
		inc	a	;ld	a,2
		call	activateobject
		jr	Yard_retnoverb

Yard_pu_cage:	ld	hl,flags5
		set	flag5_cagetaken,(hl)
		set	flag3_gotcage,(iy+asm_flag3)
		xor	a
		ld	(Yard_ObjFlags+1+01),a
		call	Yard_LoadOF
		ld	a,1
		ld	(objsInventory+INV_Cage*objSIZE),a
		xor	a
		call	activateobject
		jr	Yard_retnoverb

Yard_LoadOF:	ld	de,Yard_ObjFlags
		jp	LoadObjectFlags

Yard_ObjFlags:	defb	5
		defm	1,1,1,1,1


;----------------------------------------------------------------------------


Cott_Enter:	ld	a,ROOM_Cott
		ld	hl,Cott_Objects
		call	LoadRoom
		ld	l,gfx_maneyes
		ld	(forcemangfx),hl
		set	flag1_forcemangfx,(iy+asm_flag1)

		ld	hl,46*256+19
		xor	a
		call	setposanddir

Cott_Loop:	call	UDHandleInput
		jr	z,Cott_Loop
		cp	HI_Quit
		ret	z
		cp	HI_WalkTo
		jr	z,Cott_WalkTo
		cp	HI_PickUp
		jr	z,Cott_PickUp
Cott_retnoverb:	xor	a
		ld	(currverb),a
		jr	Cott_Loop

Cott_WalkTo:	ld	a,(curronum)
		or	a
		jr	nz,Cott_Loop

		res	flag1_forcemangfx,(iy+asm_flag1)
		jp	OSCott_Enter

Cott_PickUp:	ld	a,(curronum)
		dec	a	;cp 1
		jr	z,Cott_pu_st
		dec	a	;cp 2
		jr	z,Cott_pu_fr
		call	cantpickup
		jr	Cott_retnoverb

Cott_pu_st:	ld	l,txt_whenfeelingdog
		call	sayman
		ld	b,3
		call	UDDelay
		ld	a,60
		ld	(dogeyesx),a
		ld	hl,flags5
		set	flag5_dispdogeyes,(hl)
		ld	l,txt_grr
		call	unpacktext
		ld	(text1txt),hl
		ld	hl,30*256+60
		ld	(text1xpos),hl
		set	flag1_Text1,(iy+asm_flag1)
		;ld	b,16
		call	UDDelay16
		ld	l,txt_uhoh
		call	sayman
		ld	hl,wooftable
		ld	b,3
Cott_pu_st_lp1:	push	bc
		ld	e,(hl)
		inc	hl
		ld	d,(hl)
		inc	hl
		ld	(text1xpos),de
		push	hl
		ld	a,(hl)
		call	locateobjectname
		ld	(text1txt),hl
		ld	b,9
Cott_pu_st_lp2:	push	bc
		ld	hl,dogeyesx
		dec	(hl)
		dec	(hl)
		call	UpdateDisplay
		pop	bc
		djnz	Cott_pu_st_lp2
		pop	hl
		inc	hl
		pop	bc
		djnz	Cott_pu_st_lp1
		res	flag1_Text1,(iy+asm_flag1)
		ld	hl,flags5
		res	flag5_dispdogeyes,(hl)
		xor	a
		ld	(Cott_Objects+01*objSIZE),a
		inc	a
		ld	(Cott_Objects+02*objSIZE),a
		inc	a	;ld a,2
		call	activateobject
Cott_pu_retnvb:	jp	Cott_retnoverb

Cott_pu_fr:	xor	a
		ld	(Cott_Objects+02*objSIZE),a
		call	activateobject
		ld	a,1
		ld	(objsInventory+INV_FishingRod*objSIZE),a
		ld	hl,flags6
		set	flag6_gotfishingrod,(hl)
		jr	Cott_pu_retnvb

		;	f,xx,yy,up,dn,lt,rt,mx,my,md		 id
		;	---------------------------------------------
Cott_Objects:	defm	1,19,25,-1,-1,-1,01,19,46,01		;00
		defb	txt_door
		defb	txt_toodarktosee

		defm	1,79,34,-1,-1,00,02,59,50,02		;01
		defb	txt_something
		defb	txt_toodarktosee

		defm	0,82,34,-1,-1,01,-1,66,50,02		;02
		defb	txt_somethingelse
		defb	txt_toodarktosee


;----------------------------------------------------------------------------


Girl_Enter:	ld	a,ROOM_Girl
		call	LoadRoomDef
		;call	Girl_LoadOF

		ld	hl,36*256+53
		ld	a,3
		call	setposanddir

Girl_Loop:	call	UDHandleInput
		jr	z,Girl_Loop
		cp	HI_Quit
		ret	z
		cp	HI_Use
		jr	z,Girl_Use
		cp	HI_UseWith
		jr	z,Girl_UseWith
Girl_retnoverb:	xor	a
		ld	(currverb),a
		jr	Girl_Loop

Girl_Use:	ld	a,(curronum)
		cp	04		;drawer
		jr	nz,Girl_u_cdt
		ld	hl,flags6
		bit	flag6_gotcard,(hl)
		jr	nz,Girl_udraw_emp
		bit	flag6_drawerunlocked,(hl)
		jr	nz,Girl_udraw_ok
		ld	l,txt_itslocked
		call	sayman
		jr	Girl_retnoverb

Girl_udraw_ok:	set	flag6_gotcard,(hl)
		ld	a,1
		ld	(objsInventory+INV_Card*objSIZE),a
		ld	l,txt_foundcard
		call	sayman
		jr	Girl_retnoverb

Girl_udraw_emp:	ld	l,txt_itsempty
		call	sayman
		jr	Girl_retnoverb

Girl_UseWith:	ld	a,(currverb)
		cp	VERB_UseKey
		jr	nz,Girl_u_cdt
		ld	a,(curronum)
		cp	04		;drawer
		jr	nz,Girl_u_cdt

		call	walktocurrobj
		ld	hl,flags6
		bit	flag6_drawerunlocked,(hl)
		jr	nz,Girl_retnoverb
		set	flag6_drawerunlocked,(hl)
		ld	l,txt_drawerunlocked
		call	sayman
		jr	Girl_retnoverb

Girl_u_cdt:	call	cantdothat
		jr	Girl_retnoverb


Girl_LoadOF:	;ld	de,Girl_ObjFlags
		;jp	LoadObjectFlags

Girl_ObjFlags:	;defb	5
		;defm	1,1,1,1,1


;----------------------------------------------------------------------------

EndSequence:	;ld	b,8
		call	UDDelay16
		call	_GRBUFCLR
		ld	hl,101ch
		ld	(PENCOL),hl
		ld	l,txt_meanwhile
		call	unpacktext
		res	textInverse,(iy+textflags)
		call	_vputs
		ld	b,100
ESeq_w81:	push	bc
		call	_GRBUFCPY
		pop	bc
		djnz	ESeq_w81

		ld	a,ROOM_OSBar
		call	LoadRoomDef
		ld	hl,3644h
		ld	(girlxpos),hl
		set	flag1_dontdrawman,(iy+asm_flag1)
		set	flag2_displaygirl,(iy+asm_flag2)
		res	flag2_laughingmanon,(iy+asm_flag2)

		call	UDDelay16

		ld	l,txt_epilogue1
		call	saygirl
		call	UDDelay5
		ld	l,txt_epilogue2
		call	saylaughingman
		call	UDDelay5
		ld	l,txt_epilogue3
		call	saygirl

		call	UDDelay16

		ld	hl,txt_hahaha
		ld	(text0txt),hl
		ld	de,0a15h
		ld	(text0xpos),de
		set	flag1_Text0,(iy+asm_flag1)

		call	UDDelay16

		ld	a,123+24
		ld	(introscrolltxtlen),a
		xor	a
		ld	(scrollpos),a
		ld	l,txt_endscrolltext

		res	textInverse,(iy+textflags)

		;...

;------------------------------------------------------------------------------

Intro:		push	hl
		ld	de,background
		call	copy24spaces
		pop	hl
		push	de
		call	unpacktext
		pop	de
		call	_strCopy
		call	copy24spaces

Intro_lp:	ld	b,3
Intro_innerlp:	push	bc

		call	_GRBUFCLR
		ld	l,txt_strandedlogo	;not really a text...
		call	unpacktext
		ld	de,PLOTSSCREEN+12*20
		ld	bc,14*12
		ldir

		ld	a,(scrollpos)
		ld	c,a
		xor	a
		ld	e,a			;e is x counter
		ld	d,a
		ld	b,a			;zero the msbs
Intro_xlp:	push	af
		ld	(PENCOL),a
		ld	a,e
		sub	c
		and	7
		push	de
		ld	hl,sinustable
		ld	e,a
		;ld	d,0
		add	hl,de
		ld	a,(hl)
		pop	de
		ld	(PENROW),a
		ld	hl,background+3
		add	hl,bc			;get start of visible text
		add	hl,de			;get current char
		ld	a,(hl)
		push	de
		push	bc
		call	_vputmap
		pop	bc
		pop	de
		inc	e
		pop	af
		add	a,5
		cp	19*5			;chars on screen
		jr	nz,Intro_xlp

		ld	hl,PLOTSSCREEN
		ld	b,63
Intro_sinbg_2:	push	bc
		ld	b,3
Intro_sinbg_1:	ld	a,ffh
		xor	(hl)
		ld	(hl),a
		inc	hl
		djnz	Intro_sinbg_1
		pop	bc
		push	hl
		ld	hl,sinusbgoffset
		ld	a,(hl)
		inc	(hl)
		and	15
		ld	hl,sinusbackground
		call	_POINTHLIND
		ld	a,l
		pop	hl
		xor	(hl)
		ld	(hl),a
		ld	de,9
		add	hl,de
		djnz	Intro_sinbg_2

		call	_GRBUFCPY

		pop	bc
		djnz	Intro_innerlp

		ld	hl,scrollpos
		ld	a,(introscrolltxtlen)
		ld	b,a
		ld	a,(hl)
		inc	a
		cp	b
		jr	nz,Intro_nores
		xor	a
Intro_nores:	ld	(hl),a

		in	a,(3)
		bit	3,a
		jp	z,QuitPop
		call	Check2nd
		jp	nz,Intro_lp
		set	flag1_KeyPressed,(iy+asm_flag1)

		ret


; Dynamically allocated memory starts here.

textunpackbuffer:
